
#
# Redirection to the right macro depending on the ROOT version
#

# and now the version string given by cmake
STRING(REGEX REPLACE "^([0-9]+)\\.[0-9][0-9]+\\/[0-9][0-9]+.*" "\\1" found_root_major_vers "${ROOTVERSION}")
STRING(REGEX REPLACE "^[0-9]+\\.([0-9][0-9])+\\/[0-9][0-9]+.*" "\\1" found_root_minor_vers "${ROOTVERSION}")
STRING(REGEX REPLACE "^[0-9]+\\.[0-9][0-9]+\\/([0-9][0-9]+).*" "\\1" found_root_patch_vers "${ROOTVERSION}")

IF (found_root_major_vers LESS 5)
    MESSAGE( FATAL_ERROR "Invalid ROOT version \"${ROOTERSION}\", at least major version 4 is required, e.g. \"5.00/00\"")
ENDIF (found_root_major_vers LESS 5)
#
IF (found_root_major_vers LESS 6)
    include(Root5NewMacros)
    set(DIC_CINT)
    MESSAGE("[Gw] Dictionary Build using ROOTCINT")
ELSE(found_root_major_vers LESS 6)
    include(Root6NewMacros)
    set(DIC_CLING)
    MESSAGE("[Gw] Dictionary Build using ROOTCLING")
ENDIF(found_root_major_vers LESS 6)

