
/** Function to integrate the areas between markers */
void Area1()
{   
   const Int_t MAXMARKERS = 100 ;
   Int_t i, nbmarkers; Stat_t x[MAXMARKERS], areas[MAXMARKERS]; Int_t ind[MAXMARKERS];
      
   // Area1 is an action on pad
   if ( TVirtualPad::Pad() == NULL ) return;
   
   // look for an histogram and markers in the current pad
   TH1 *hist;
   TIter next(gPad->GetListOfPrimitives());

   hist = NULL; nbmarkers = 0;
   while ( (obj = next()) ) { 
 	 if ( obj->InheritsFrom("TMarker") ) {
                x[nbmarkers++]   = ((TMarker*)obj)->GetX();
	 }
	 if ( obj->InheritsFrom("TH1") ) { hist = (TH1 *)obj; }
   }
   if ( hist == NULL || nbmarkers < 2 ) {
	printf("There is no histograms or enough clicks in the current pad to realise an integration \n"); return; }
	
   TMath::Sort(nbmarkers,x,ind,false); // in case markers have been added without order
   
   // compute the area between two consecutives markers
   Double_t integral = 0.0; Int_t first_bin, last_bin; Stat_t first_bin_c, last_bin_c; 
     
   for ( i = 0; i < nbmarkers - 1; i++ ) {
  	
   	first_bin = hist->FindBin( x[ind[i]] );  last_bin = hist->FindBin( x[ind[i+1]] );
	Double_t sum = 0.0;
   	for (Int_t bin = first_bin; bin < last_bin; bin++ ) {
     		sum += hist->GetBinWidth(bin)*hist->GetBinContent(bin);
 //    		meanx    += hist->GetBinCenter(i)*hist->GetBinContent(i);
   	}	
	areas[i] = sum; integral += sum;
   }
   
   printf("\n");
   printf("******************* AREA1 RESULTS ******************* \n"); 
   for ( i = 0; i < nbmarkers - 1; i++ ) {  // now write results on the standardoutput
   	first_bin = hist->FindBin( x[ind[i]] ); last_bin = hist->FindBin( x[ind[i+1]] );   
   	if ( integral == 0.0 ) {
   		printf(" Integral %d from %.1f (%d) to %1.f (%d): %1.f  \n",i,x[ind[i]],first_bin,x[ind[i+1]],last_bin,areas[i]);	
	}
	else {
   		printf(" Integral %d from %.1f (%d) to %1.f (%d): %1.f  (%.1f \%) \n",i,x[ind[i]],first_bin,x[ind[i+1]],last_bin,areas[i],100.0*areas[i]/integral);
	}
   }   
   printf("\n"); 
   printf(" Total from %.1f (%d) to %1.f (%d): %1.f  \n",x[ind[0]],first_bin,x[ind[nbmarkers-1]],last_bin,integral);	   
   printf("***************************************************** \n");
   
}


