
/** Function to fill areas between markers */
void FillIt()
{   
   const Int_t MAXMARKERS = 100; Int_t i, nbmarkers; Stat_t x[MAXMARKERS]; Int_t ind[MAXMARKERS]; TList markers; markers.SetOwner(false);
      
   // this is an action on pad
   if ( TVirtualPad::Pad() == NULL ) return;
   
   // look for an histogram and markers in the current pad
   TH1 *hist;
   TIter next(TVirtualPad::Pad()->GetListOfPrimitives());

   hist = NULL; nbmarkers = 0;
   while ( (obj = next()) ) { 
 	 if ( obj->InheritsFrom("TMarker") ) {
	 	x[nbmarkers] = ((TMarker*)obj)->GetX(); markers.AddAt(obj,nbmarkers); nbmarkers++;
	 }
	 if ( obj->InheritsFrom("TH1") ) { hist = (TH1 *)obj; }
   }
   if ( hist == NULL || nbmarkers < 2 ) {
	printf("There is no histograms or enough clicks in the current pad to realise an integration \n"); return; }
	
   TMath::Sort(nbmarkers,x,ind,false); // in case markers have been added without order
   
   Int_t first_bin, last_bin; Stat_t first_bin_c, last_bin_c; 
     
   for ( i = 0; i < nbmarkers - 1; i++ ) {
  	
	TH1 *clone = hist->Clone(); clone->Reset("ICE"); clone->SetFillColor( ((TMarker *)markers.At(ind[i]))->GetMarkerColor() );
	
	if ( i % 2 == 0 )  clone->SetFillStyle(3004);
	else clone->SetFillStyle(3005);
	
   	first_bin = hist->FindBin( x[ind[i]] ); 
	last_bin  = hist->FindBin( x[ind[i+1]] );
   	for (Int_t bin = first_bin; bin < last_bin; bin++ ) { clone->SetBinContent(bin,hist->GetBinContent(bin)); }
	
	clone->Draw("same");	
   }
}


