#!/usr/bin/env python

import os
import shutil
import getopt, sys

# part to be changed by configure/cmake
L_LIBDIR   = "@GW_LIB_DIR@"
L_BINDIR   = "@GW_BIN_DIR@"
L_INCDIR   = "@GW_INCLUDE_DIR@"
L_VERSION  = "@GammaWare_VERSION@"
L_RVERSION = "@ROOTVERSION@"
L_CMAKEGWMODULESDIR = "@CMAKE_GWMODULES_DIR@"

# print help and current conditions
help = """
 Usage : Gw-config.py --opt
		
	possible options :
	
		* --h        : print help
		* --libdir   : to get the path to the libraries for the current version
		* --bindir   : to get the path to the binaries  for the current version
		* --incdir   : to get the path to the includes  for the current version
		* --version  : to get the current running version
		* --cmakegwmodule  : to get the path to cmake modules proper to GW
		
		* --rootversion : to get the root version used to compile this version
		
"""

def Usage() :
	print	
	print ' ***********************************************************************'
	print help	
	print ' ****** in case of questions/problems, agata{_{at}_}ipnl.in2p3.fr ******'
	print	

def main():
	global ARCH, FORCE_ARCH
	if (sys.version_info < (2,3,4) ) :
		raise "Version python min required 2.3.4 !"
		
	# check options
	try:
		opts, args = getopt.getopt(sys.argv[1:], "h", [
			"help", "libdir", "bindir", "incdir", "cmakegwmodule", "version", "rootversion"])
	except getopt.GetoptError, err:
		print ''
		print str(err)
		Usage()
		sys.exit(2)

	# display help
	for index in range(len(opts)) :
		if ( opts[index][0] == '-h' ) :
			Usage()
			return 0
	
	for index in range(len(opts)) :
		if ( opts[index][0] == '--libdir' ) :
			sys.exit(L_LIBDIR)		
		if ( opts[index][0] == '--bindir' ) :
			sys.exit(L_BINDIR)
		if ( opts[index][0] == '--incdir' ) :
			sys.exit(L_INCDIR)
		if ( opts[index][0] == '--version' ) :
			sys.exit(L_VERSION)
		if ( opts[index][0] == '--rootversion' ) :
			sys.exit(L_RVERSION)
		if ( opts[index][0] == '--cmakegwmodule' ) :
			sys.exit(L_CMAKEGWMODULESDIR)
	Usage()

# execute main 
if __name__ == "__main__":
	main()