/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** @file AgataCompositeFrame.h header file for AgataCompositeFrame.cpp */

#ifndef ADF_AgataCompositeFrame
#define ADF_AgataCompositeFrame

#ifndef ADF_CompositeFrame
#include "CompositeFrame.h"
#endif

namespace ADF
{ 

class AgataFrameFactory;

//! General interface 
/*!

*/
class AgataCompositeFrame : public CompositeFrame
{
	friend class AgataFrameFactory;
protected:
	AgataCompositeFrame(Key *akey, const FactoryItem &secondary_key): CompositeFrame(akey,FactoryItem("Agata",secondary_key.GetFactoryVersion(),secondary_key.GetItemName().data(),secondary_key.GetVersion())) 
		{;} 
public:	
	virtual ~AgataCompositeFrame() 
		{;}     
};

} // namespace ADF
#endif



