/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** \file AgataConfigurationFrame.cpp compiled in libGWADF.so */

#ifndef ADF_AgataConfigurationFrame
#include "AgataConfigurationFrame.h"
#endif

using namespace ADF; 

UInt_t AgataConfigurationFrame::Write() 
{
	UInt_t offset = ( String().size() + GetKey()->GetKeyLength() ) % 8u;
	
	// add 0 so that the length of the Frame is divided by 8 bytes (64 alignement)
	if ( offset > 0u ) {
		char c = 0;
		String().append(8u - offset, c);
	}
	
	return ConfigurationFrame::Write();
}




 
    
