/***************************************************************************
 *   Copyright (C) 2007 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** @file AgataFrameFactory.h header file for AgataFrameFactory.cpp */

#ifndef ADF_AgataFrameFactory
#define ADF_AgataFrameFactory
#define ADF_AGATAFRAMEFACTORY_H ADF_AgataFrameFactory

#ifndef ADF_FrameFactory
#include "FrameFactory.h"
#endif

#ifndef ADF_Frame
#include "Frame.h"
#endif

#ifndef ADF_GenericFrame
#include "GenericFrame.h"
#endif

#ifndef ADF_ADFObjects
#include "ADFObjects.h"
#endif

namespace ADF
{ 

//! AgataFrameFactory, implements agata's like Frame Factory
/*!
*/
class AgataFrameFactory : public AFrameFactory<AgataFrameFactory>
{
	friend class AFrameFactory<AgataFrameFactory>;

private:
	AgataFrameFactory (); 
	virtual ~AgataFrameFactory () 
		{;}

protected: 
	//! Ask this factory for a new Agata Frame
	/*!
	*/     
	virtual SharedFP *DoNew(Key *, const FactoryItem &); 
}; 


} // namespace ADF
#endif





