/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** @file AgataRawFrame.h header file for AgataRawFrame.cpp */

#ifndef ADF_AgataRawFrame
#define ADF_AgataRawFrame

#ifndef ADF_Frame
#include "Frame.h"
#endif

namespace ADF
{ 

//! A AgataRawFrame gives direct access to the underlying buffer
/*!
	It takes care also to add 0 at the end of the buffer when writting to have 64 bits aligned Frames  
*/
class AgataRawFrame : public RawFrame
{
	friend class AgataFrameFactory;
	
protected:
	AgataRawFrame(Key *key): RawFrame(key) 
		{;}		
public:
	virtual ~AgataRawFrame()
		{;}	
 
	//! It just set the size of the frame from the current position in the buffer
	/*!
		Starting from an offset equal to zero, when the buffer is filled 
		just call this method.
	*/    
	virtual UInt_t Write() ;
};

} // namespace ADF
#endif



