/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/** @file BlackHole.h header file for BlackHole.cpp */

#ifndef _BlackHole
#define _BlackHole

#ifndef ADF_NarvalInterface
#include "NarvalInterface.h"
#endif

//! black hole. It consumes data and just counts the number of bytes consumed 
/*!
 */
class BlackHole : public ADF::NarvalConsumer 
{   
private:
	ULong64_t fConsumedBytes;
	
public:
	BlackHole();
 	virtual ~BlackHole(); 
	
	//! to init globals (static) from a directory
	static void process_config (const Char_t *, UInt_t *) ;
	
	//! Constructor implementation 	
	virtual	void process_initialise (UInt_t *error_code);
	
	//! Destructor implementation  
	virtual	void process_reset (UInt_t *error_code);
	
	virtual UInt_t ProcessBlock (ADF::FrameBlock &) ;
	
};

#endif
