/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/** \file ConfigurationFrame.cpp compiled in libGWADF.so */


#ifndef ADF_ConfigurationFrame
#include "ConfigurationFrame.h"
#endif

using namespace ADF; 

ConfigurationFrame::ConfigurationFrame(Key *key) : 
ConcreteFrame(key), 
fString() 
{
	// a configuration rame is evolutive and by default allows of everthing
	// Migration SharedFP	SetFrameChangeFunction(ChangeOfVersion);
}

UInt_t ConfigurationFrame::Read()
{
	fString = ""; 
	const char *buf = 
	fBuffer->GetAddress();
	fString.assign(buf,fKey->GetDataLength());
	
	return UInt_t(fString.size());
}

UInt_t ConfigurationFrame::Write()
{
	UInt_t size_to_write = UInt_t(fString.size());
	fBuffer->SetOffset();
	
	if ( !fBuffer->Reserve(UInt_t(size_to_write)) ) { // check if enough place
		fKey->SetDataLength(0u);
		return 0u;
	}
	if ( (*fBuffer).Copy(fString.data(),size_to_write) )
		fKey->SetDataLength(size_to_write);
	else 
		fKey->SetDataLength(0u);	
	
	return fKey->GetDataLength();
}

/*
 Bool_t  ConfigurationFrame::ChangeFrame(const Version &version)
 {
 FactoryItem newitem(GetSignature());
 
 newitem.SetVersion(version);
 SetSignature(newitem);
 
 return true;
 }
 */	






