/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** @file Frame.h header file for Frame.cpp */

#ifndef ADF_ConfigurationFrame
#define ADF_ConfigurationFrame

#ifndef ADF_Frame
#include "Frame.h"
#endif

#include <string>

namespace ADF
{ 

//! A configuration frame is just an encapsulation of a string
/*!
	
*/
class ConfigurationFrame : public ConcreteFrame
{
private:
	std::string fString;
    
public:
	explicit ConfigurationFrame(Key *key);
	virtual ~ConfigurationFrame() 
		{;}
		
	std::string &String() 
		{ return fString; }
	
	//! It reads the content of the string from the Frame 
	/*!
		return the number of bytes read (= string length)
	*/  
	virtual UInt_t Read(); 
	
	//! It writes to the Frame the content of the string
	/*!
		return the number of bytes written (= string length)
	*/    	
	virtual UInt_t Write(); 
};


} // namespace ADF
#endif




