/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** \file DataHandling.cpp compiled in libGWADF.so */

#ifndef ADF_DataHandling
#include "DataHandling.h"
#endif
#include <time.h> 
#include <math.h>

const char *ADF::NamedItemTypeOf(Bool_t)   
	{ return kBool_t; } 
const char *ADF::NamedItemTypeOf(UShort_t) 
	{ return kUShort_t; } 
const char *ADF::NamedItemTypeOf(Short_t)
	{ return kShort_t; }  
const char *ADF::NamedItemTypeOf(UInt_t) 
	{ return kUInt_t; } 
const char *ADF::NamedItemTypeOf(Int_t)
	{ return kInt_t; } 
const char *ADF::NamedItemTypeOf(ULong64_t) 
	{ return kULong64_t; } 
const char *ADF::NamedItemTypeOf(Long64_t)
	{ return kLong64_t; } 
const char *ADF::NamedItemTypeOf(Double_t) 
	{ return kDouble_t; } 
const char *ADF::NamedItemTypeOf(Float_t)
	{ return kFloat_t; } 
const char *ADF::NamedItemTypeOf(std::string)
	{ return kString_t; } 

using namespace ADF;

Digitizer::Digitizer(Double_t xmin, Double_t xmax, UInt_t bins) 
{	
	Digitizer::Init(xmin,xmax,bins); ::srand((unsigned int)time(NULL));
}

void Digitizer::Init(Double_t xmin, Double_t xmax, UInt_t bins)
{
	fXmin = xmin; fXmax = xmax;  

 	if ( xmin > xmax ) 
		{ fXmax = xmin; fXmin = xmax; } // just in case
	
	fDeltaX = fXmax - fXmin;
	
	if ( bins > ADF::kMaxUShort_t )
		fNBins2 = ADF::kMaxUShort_t; 
	else
		fNBins2 = UShort_t(bins);
		
	fNBins4	 = bins ;
}







	

