/***************************************************************************
 *   Copyright (C) 2007 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** @file DefaultFrameFactory.h header file for DefaultFrameFactory.cpp */

#ifndef ADF_DefaultFrameFactory
#define ADF_DefaultFrameFactory

#include "FrameFactory.h"
#include "Frame.h"
#include "GenericFrame.h"

namespace ADF
{ 

//! DefaultFrameFactory,
/*!
*/
class DefaultFrameFactory : public AFrameFactory<DefaultFrameFactory>
{
	friend class AFrameFactory<DefaultFrameFactory>;

private:
	DefaultFrameFactory (); 
	virtual ~DefaultFrameFactory () 
		{;}

protected: 
	//! Ask this factory for a new Frame
	/*!
	*/     
	virtual SharedFP *DoNew(Key *, const FactoryItem &); 
}; 


} // namespace ADF
#endif





