/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** \file Hits.cpp compiled in libGWADF.so */

#include "Hits.h"

using namespace ADF; 
  
void Hit::SetHit(const Hit &ahit)
{
	// position
	SetXYZ(ahit.GetX(),ahit.GetY(),ahit.GetZ());
	// error on position
	SetDXYZ(ahit.GetDX(),ahit.GetDY(),ahit.GetDZ());
	
	// energy and time
	SetE(ahit.GetE()); SetDE(ahit.GetDE());
	SetT(ahit.GetT()); SetDT(ahit.GetDT());
	
	// status and ID
	SetStatus(ahit.GetStatus());
	SetID(ahit.GetID());
}




    
    
