/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** \file Signals.cpp compiled in libGWADF.so */

#include "Signals.h"

using namespace ADF; 

Signal *Signal::New(UInt_t length, const char *type) 
{
	Signal *sig = NULL; std::string stype = type;
	
	// allocate the proper type
	if ( stype.compare(kUShort_t) == 0 ) 
		sig = new SignalUS(length); 
	if ( stype.compare(kShort_t) == 0 ) 
		sig = new SignalS(length);
	if ( stype.compare(kUInt_t) == 0 ) 
		sig = new SignalUI(length); 
	if ( stype.compare(kInt_t) == 0 ) 
		sig = new SignalI(length);	
	if ( stype.compare(kFloat_t) == 0 ) 
		sig = new SignalF(length); 
	if ( stype.compare(kDouble_t) == 0 ) 
		sig = new SignalD(length); 
	
	// What if the given string does not correspond to a good type ??	
	if ( sig == NULL ) 
		sig = new SignalUS(length);
	
	return sig;
}




    
    
