
#ifndef _CentralLog
#include "CentralLog.h"
#endif

#ifndef ADF_NarvalCollector
#include "narval/NarvalCollector.h"
#endif

#include "ATNBasicAFC.h"

void process_config (const char *directory_path, UInt_t *error_code)
{
  BasicAFC::process_config (directory_path, error_code);
}

BasicAFC *process_register (UInt_t *error_code) 
{ 
	// the current collector should be Narval !  
	if ( ! CentralLog::theCentralLog()->IsCollector("NarvalCollector") ) {
		CentralLog::theCentralLog()->Add( new ADF::NarvalCollector("NarvalCollector",true) );
	}
	CentralLog::theCentralLog()->ChangeCollector(std::string("NarvalCollector"));
	
	return new BasicAFC(); 
}

void process_block (BasicAFC *algo_data,void *input_buffer, UInt_t size_of_input_buffer, UInt_t *error_code)
{
  algo_data->process_block (input_buffer, size_of_input_buffer,error_code);
}

void process_initialise (BasicAFC *algo_data, UInt_t *error_code)
{
  algo_data->process_initialise (error_code);
}
void process_reset (BasicAFC *algo_data,UInt_t *error_code)
{
  algo_data->process_reset (error_code);
}
void process_start (BasicAFC *algo_data, UInt_t *error_code)
{
  algo_data->process_start (error_code);
}
void process_stop (BasicAFC *algo_data,UInt_t *error_code)
{
  algo_data->process_stop (error_code);
}
void process_pause (BasicAFC *algo_data,UInt_t *error_code)
{
  algo_data->process_pause (error_code);
}
void process_resume (BasicAFC *algo_data, UInt_t *error_code)
{
  algo_data->process_resume (error_code);
}


