
#ifndef _CentralLog
#include "CentralLog.h"
#endif

#ifndef ADF_NarvalCollector
#include "narval/NarvalCollector.h"
#endif

#include "ATNBasicAFP.h"

void process_config (const char *directory_path, UInt_t *error_code)
{
  BasicAFP::process_config (directory_path, error_code);
}

BasicAFP *process_register (UInt_t *error_code) 
{ 
	// the current collector should be Narval !  
	if ( ! CentralLog::theCentralLog()->IsCollector("NarvalCollector") ) {
		CentralLog::theCentralLog()->Add( new ADF::NarvalCollector("NarvalCollector",true) );
	}
	CentralLog::theCentralLog()->ChangeCollector(std::string("NarvalCollector"));
	
	return new BasicAFP(); 
}

/*void process_unload (BasicAFP *algo_data, UInt_t *error_code)
{
  algo_data->process_unload (error_code);
}*/

void process_block (BasicAFP *algo_data, void *output_buffer,
		      UInt_t size_of_output_buffer,
		      UInt_t *used_size_of_output_buffer,
		      UInt_t *error_code)
{
  algo_data->process_block 
  	(output_buffer,size_of_output_buffer,used_size_of_output_buffer,error_code);
}

void process_initialise (BasicAFP *algo_data, UInt_t *error_code)
{
  algo_data->process_initialise (error_code);
}
void process_reset (BasicAFP *algo_data,UInt_t *error_code)
{
  algo_data->process_reset (error_code);
}
void process_start (BasicAFP *algo_data, UInt_t *error_code)
{
  algo_data->process_start (error_code);
}
void process_stop (BasicAFP *algo_data,UInt_t *error_code)
{
  algo_data->process_stop (error_code);
}
void process_pause (BasicAFP *algo_data,UInt_t *error_code)
{
  algo_data->process_pause (error_code);
}
void process_resume (BasicAFP *algo_data, UInt_t *error_code)
{
  algo_data->process_resume (error_code);
}

