/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                                  *
 *                                                                         *
 *   This program is _ree so_tware; you can redistribute it and/or modi_y  *
 *   it under the terms o_ the GNU General Public License as published by  *
 *   the Free So_tware Foundation; either version 2 o_ the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be use_ul,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty o_        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License _or more details.                          *
 *                                                                         *
 *   You should have received a copy o_ the GNU General Public License     *
 *   aLong_t with this program; i_ not, write to the                         *
 *   Free So_tware Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** \file AlgoDummy.cpp compiled in libGWADF.so */

#ifndef _AlgoDummy
#include "AlgoDummy.h"
#endif

Double_t AlgoDummy::UnitPosition = 1.;
Double_t AlgoDummy::UnitEnergy   = 1.; 

AlgoDummy::AlgoDummy() : ADF::Algo(), XM(0.0), YM(0.0), ZM(0.0), EM(0.0), ID(0u), Mult(0u)
{
	for (UInt_t i = 0u; i < MAXSIZE; i++ ){ X[i] = Y[i] = Z[i] = E[i] = 0.0; } 	
}
  
AlgoDummy::~AlgoDummy()
{
// destructor
}

#include <stdlib.h>
#include <stdio.h>

Int_t AlgoDummy::SetInput() 
{
	UInt_t _Mult = UInt_t ( MAXSIZE * Double_t(::rand())/RAND_MAX ) ;
	
	for(UInt_t i = 0u; i < _Mult ; i++){
		X[i] = UnitPosition*Double_t(::rand())/RAND_MAX; 
		Y[i] = UnitPosition*Double_t(::rand())/RAND_MAX; 
		Z[i] = UnitPosition*Double_t(::rand())/RAND_MAX; 
		
		E[i] = UnitEnergy*Double_t(::rand())/RAND_MAX; 	
	}
	
	printf(" Fill input with random values [0] : X %f Y %f Z %f E %f \n",X[0],Y[0],Z[0],E[0]) ; 
	
	return 0;
}
    
Int_t AlgoDummy::Process()  
{ 
	XM = YM = ZM = EM = 0.0; if ( Mult == 0u ) return 0;
	
	for(UInt_t i = 0u; i < Mult ; i++) {
		XM += X[i]; YM += Y[i] ; ZM += Z[i]; 
		EM += E[i]; 	
	}	
	XM /= Mult;
	YM /= Mult;	
	ZM /= Mult;	
	EM /= Mult;	
		
	return 0;	
}  
 
Int_t AlgoDummy::SetOutput() 
{ 
	printf(" show output on standard output. Mean value : X %f Y %f Z %f E %f  \n",XM,YM,ZM,EM) ; 

	return 0;
} 

    
    
