/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3._r                                                  *
 *                                                                         *
 *   This program is _ree so_tware; you can redistribute it and/or modi_y  *
 *   it under the terms o_ the GNU General Public License as published by  *
 *   the Free So_tware Foundation; either version 2 o_ the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be use_ul,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty o_        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License _or more details.                          *
 *                                                                         *
 *   You should have received a copy o_ the GNU General Public License     *
 *   aLong_t with this program; i_ not, write to the                         *
 *   Free So_tware Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** @file AlgoDummy.h header file for AlgoDummy.cpp */

#ifndef _AlgoDummy
#define _AlgoDummy

#ifndef ADF_Algo
#include "Algo.h"
#endif

//! Base class for a dummy algorithm
/*!
	It reads a list of hits (x,y,z,e) and computes the means value = single hit (xmean,ymean,zmean,emean)
*/
class AlgoDummy : public ADF::Algo
{   
public:
    static const UInt_t MAXSIZE = 10u; 
    
protected:
    // here comes you local variables/parameters your algo is processing 
     
    // static
    static Double_t UnitPosition;
    static Double_t UnitEnergy;    
    
    // non-static 
    Double_t XM;	// x-mean (out)
    Double_t YM;	// y-mean (out)
    Double_t ZM;	// z-mean (out)
        
    Double_t EM;	// e-mean (out)  
    
    UShort_t ID;	// an ID (in)
    
    UInt_t   Mult;	// the nomber of hits (in)   
   
    Double_t X[MAXSIZE]; // x positions of each hit (in)
    Double_t Y[MAXSIZE]; // y positions of each hit (in) 
    Double_t Z[MAXSIZE]; // z positions of each hit (in)  
        
    Double_t E[MAXSIZE]; // e positions of each hit (in)  
 
public:   
    AlgoDummy();  
    virtual ~AlgoDummy() ;
    
    //! To get the name of that algorithm  
    virtual const Char_t *GetName() { return "A Dummy algorithm"; }
        
    //! To fill the local variables with input values
    /*!
    	In this version, the input values are generated randomly
    */   
    virtual Int_t SetInput();
    
    //! To Process the algorithm
    /*!
    */      
    virtual Int_t Process(); 
    
    //! To fill the ouput variables with the result of the algorithm
    /*!
    */       
    virtual Int_t SetOutput();      
}; 

#endif





