


#include <sys/times.h>

#include <iostream>
#include <sstream>
#include <string>

/*
compilation: 
	g++ -O -Wall -fPIC -I./ -L./ -lADF dev/testSignal.c -o testSignal
	g++ -g -pg -I./ -L./ -lADF dev/testSignal.c -o testSignal 
	
--> DEBUG 
Linux SL4

--> VALGRIND

Memory leak
Profiling
	
*/

#include "ADFObjects.h"

using namespace std;
using namespace ADF;

int main(int argc, char **argv)
{	
	const UInt_t size = 10u;
	Signal *s1 = Signal::New(size,"F"); UShort_t s2[size];
	
	for (UInt_t i = 0u; i < size; i++) {
		s1->Set(i+1.1,i);
	}
	cout << "signal 1" << endl;
	for (UInt_t i = 0u; i < size; i++) {
		Float_t val;
		cout << i << " " << s1->Get(val,i) << endl;
	}

	cout << "signal 2, nb copied " << s1->Get(s2,size) << endl;	
	for (UInt_t i = 0u; i < size; i++) {
		cout << i << " " << s2[i] << endl;
	}	
	
	return 0;
}

