/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** \file NarvalCollector.cpp compiled in libADF.so !! only in standalone mode !! */

#ifndef ADF_NarvalCollector
#include "NarvalCollector.h"
#endif

#include "ADFLogMessage.h"

extern "C" {
	void ada_log_message (int, const char *,int);
} // extern C
	
using namespace ADF;

NarvalCollector::NarvalCollector(const char *name, bool isdelbycental) : 
	LogCollector(name,isdelbycental)
{
} 

NarvalCollector::~NarvalCollector() 
{
}  

int NarvalCollector::ConvertLevel(LogMessage::ELevel lev)
{	
/*	if ( lev == LogMessage::kDebug )
		return 0; */
	if ( lev == LogMessage::kError )
		return 3;
	if ( lev == LogMessage::kWarning )
		return 2;
	if ( lev == LogMessage::kInfo )
		return 1;
	
	return 1000;
}

void NarvalCollector::DoCollect(LogMessage &alogmsg)
{
	std::string mess = 
		alogmsg.Message();
	if ( mess.size() > 0 ) {
		std::string rmess = "[" +  alogmsg.GetProcessName() + "::" + alogmsg.GetProcessMethod() + "] ";
		rmess.append(mess);
		ada_log_message (alogmsg.GetPID(),rmess.c_str(),ConvertLevel(alogmsg.GetLevel()));	
	}
}





