/***************************************************************************
 *   Copyright (C) 2005-2006 by Christophe Theisen & Olivier Stezowski     *
 *   christophe.theisen(AT)cea.fr, stezow(AT)ipnl.in2p3.fr                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** \file ClickCollector.h */

#ifndef GW_CLICKCOLLECTOR_H
#define GW_CLICKCOLLECTOR_H


#include "TMarker.h"
#include "RQ_OBJECT.h"
#include "TROOT.h"
#include "TCanvas.h"

namespace GwD {

class ClickCollector 
{
RQ_OBJECT("ClickCollector")

private:
	static ClickCollector *gfCollector;	// the click collector
	
private:    
	Int_t fLastPx, fLastPy;		// to keep track of the last postion of the mouse in the pad

	EEventType fCollectMode;	// type of event needed to collect
	
	TMarker    fMarker;		// Marker attribute used to draw markers

	Bool_t	fIsActive;		// true if collect mode is on
		
private:
	ClickCollector();
  
public:
	virtual ~ClickCollector() {;}
  
	void SetMode(Bool_t mode = true) { fIsActive = mode; }
	void SetMarker(TMarker m) { fMarker = m; }

	// the unique collector
	static ClickCollector * TheCollector(); 
	
	// action to be performed for any events
	void DoCollect(Int_t event, Int_t px, Int_t py, TObject *obj);

		//! rootcint dictionary
	ClassDef(ClickCollector,0); // a ClickCollector
	
};

}

#endif
