/***************************************************************************
 *   Copyright (C) 2010 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/** \file BasicReplica.cpp compiled in libGWADF.so */


#include "BasicReplica.h"

using namespace ADF;
using namespace Gw;

UInt_t BasicReplica::ProcessBlocks() 
{ 
	UInt_t error_code = 0u;
	
	if ( !fAttachedInputBlock->IsOwner(this) ) {
		error_code = 1u;
		return error_code;
	}
	fBytesAttachedInputBlock += fAttachedInputBlock->GetSize();
	
	// to do : deal with lazy connection. lazy means if not there, just ignore it. Othermode is not lazy i.e. wait for all connections
	// here is a typical implementation for a lazy for which SetOwner is not this 
	for (size_t i = 0u; i < fAttachedOutputBlocks.size(); i++) {
		if ( fAttachedOutputBlocks[i]->IsOwner(this) ) {
			Bool_t ok_copy = fAttachedOutputBlocks[i]->SetBlock(fAttachedInputBlock->GetBufferIO()->Address(),fAttachedInputBlock->GetSize(),'-','c'); // copy, no rewind
			if ( ok_copy ) {
				fBytesAttachedOutputBlock[i] += fAttachedInputBlock->GetSize();
				fAttachedOutputBlocks[i]->SetOwner(0x0);
			}
			else 
				error_code = 1u;
		}
	}
	fAttachedInputBlock->SetOwner(0x0);
	
	return error_code; 
}

void BasicReplica::process_reset (UInt_t *error_code) 
{
	*error_code = 0;
	Log.ClearMessage(); Log.SetProcessMethod("process_reset");
		
	Log << (fBytesAttachedInputBlock / ADF::aMByte) << " [MB] duplicated on " << fAttachedOutputBlocks.size() << " outputs " << nline;
	// to be done description line but line 
	
	Log << dolog;	
}

