

#ifndef Gw_WatcherProducer
#define Gw_WatcherProducer

// ADF includes
#ifndef ADF_NarvalInterface
#include "NarvalInterface.h"
#endif

// ROOT includes
#ifndef ROOT_TSocket
#include "TSocket.h"
#endif

namespace Gw {

//! To get a buffer from a server
/*!	
	\author Olivier Stezowski	
*/
class WatcherProducer : public ADF::NarvalProducer 
{
private:
	TString fMachine;
	UInt_t  fPort;
	
	TSocket *fSocket;
	//! set timeout to try and get some new buffer 
	Long_t fTimeout; 
	
private:
	ADF::BufferIO fBuffer;
	
protected:
	//! true if a valid connection
	Bool_t  OpenSocket();
	Bool_t CloseSocket();	
public:
	WatcherProducer(): 
		ADF::NarvalProducer(), 
		fMachine("localhost"), 
		fPort(9090),
		fSocket(0x0),
		fTimeout(100),
		fBuffer(ADF::aByte)
			{;}
	virtual ~WatcherProducer();
	
	//! change timeout to try and get data from the socket 
	void SetTimeout(Long_t timeout = 10); //*MENU* 
	
	static void process_config (const Char_t *path, UInt_t *error_code)
		{ ADF::NarvalProducer::process_config(path,error_code); }
		
	//! TODO reads from a file the data to open the socket
	virtual void process_initialise (UInt_t */*error_code*/)
		{;}
	//! TODO
	virtual void process_reset (UInt_t */*error_code*/);	

	//! load the next block		
	/*!
		Warning : the inner buffer us attached to this block 
	*/
	virtual UInt_t ProcessBlock (ADF::FrameBlock &);

	//! change the place where are picked data		
	Bool_t SetConnection(const Char_t *machine ="localhost", UInt_t port = 9090);
};

} // end namespace

#endif


