/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
/** \file InfoData.cpp compiled in libGWPHYSICS.so */

#ifndef ROOT_TString
#include <TString.h>
#endif

#ifndef GW_INFODATA_H
#include "InfoData.h"
#endif

using namespace Gw;

ClassImp(InfoData);

InfoData::InfoData() : TObject(), fInfo(kKnown)
{
}

InfoData::InfoData(const InfoData &info):TObject(info) { fInfo = info.fInfo; }

InfoData::~InfoData()
{
}

InfoData::EData InfoData::WhatIs(const char *s)
{
	TString st = s; Short_t nb, nb_unkown, nb_theo_left, nb_theo_right, nb_tenta_left, nb_tenta_right, nb_about;
	
	// reads the string and counts the specfics characters
	nb = nb_unkown = nb_theo_left = nb_theo_right = nb_tenta_left = nb_tenta_right = nb_about = 0;
	Int_t end = st.Length();
	for( Int_t i = 0 ; i < end; i++ ){
		if ( st[i] == '?' ) { nb_unkown++; nb++; }
		if ( st[i] == '(' ) { nb_tenta_left++; nb++;}  ; if ( st[i] == ')' ) { nb_tenta_right++; nb++;} 	
		if ( st[i] == '[' ) { nb_theo_left++; nb++; }  ; if ( st[i] == ']' ) { nb_theo_right++; nb++; }
		if ( st[i] == '~' ) { nb_about++; nb++; }	
	}
	// set the informations 
	if ( nb  > 2 ) return kUnknown;
	if ( nb == 0 ) return kKnown;
	
	if ( nb == 1 ) {
		if ( nb_about  == 1 ) return kAbout;
		else return kUnknown;
	}
	else { // nb = 2
		if ( nb_tenta_left == 1 && nb_tenta_right == 1 ) return kTentative;
		if (  nb_theo_left == 1 &&  nb_theo_right == 1  ) return kTheo;
	}
	return kUnknown;
}


