////////////////////////////////////////////////////////////////////////////////
//									                                  //
//  BufferGANIL		      						                          //
//									                                  //
////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////

#include <TObjString.h>
#include "BufferGANIL.h"

short *BufferGANIL::gGroupTableECC   = NULL;	
short *BufferGANIL::gGroupTableESS   = NULL;	
short *BufferGANIL::gGroupTableDIA   = NULL;
short *BufferGANIL::gGroupTableGOCCE = NULL;
short *BufferGANIL::gGroupTableVAMOS = NULL;
	
int    BufferGANIL::gNbECC;	
int    BufferGANIL::gNbESS;
int    BufferGANIL::gNbDIA;
int    BufferGANIL::gNbGOCCE;
int    BufferGANIL::gNbVAMOS;

short BufferGANIL::gItemDIAE;
short BufferGANIL::gItemDIAT;
short BufferGANIL::gItemDIAID;

short BufferGANIL::gItemHR[MAXGROUPTABLE];
short BufferGANIL::gItemLR[MAXGROUPTABLE];
short BufferGANIL::gItemT[MAXGROUPTABLE];

short BufferGANIL::gItemSE;
short BufferGANIL::gItemSTAC;
short BufferGANIL::gItemSP;	
short BufferGANIL::gItemST[MAXGROUPTABLE];

short BufferGANIL::gItemSEDX0[MAXGROUPTABLE];	//!
short BufferGANIL::gItemSEDY0[MAXGROUPTABLE];	//!	
short BufferGANIL::gItemSEDX1[MAXGROUPTABLE];	//!
short BufferGANIL::gItemSEDY1[MAXGROUPTABLE];	//!
short BufferGANIL::gItemICHA[MAXGROUPTABLE];   //!	
short BufferGANIL::gItemICHB[MAXGROUPTABLE];   //!	
short BufferGANIL::gItemQSED0[MAXGROUPTABLE];  //!		
short BufferGANIL::gItemQSED1[MAXGROUPTABLE];  //!	
short BufferGANIL::gItemVAMOST[MAXGROUPTABLE];//!	

short BufferGANIL::gItemQPLG;//!			
short BufferGANIL::gItemQPLD;//!	
	
short BufferGANIL::gMaskDIAE;
short BufferGANIL::gMaskDIAT;
short BufferGANIL::gMaskDIAID;
		
short BufferGANIL::gMaskHR[MAXGROUPTABLE];
short BufferGANIL::gMaskLR[MAXGROUPTABLE];
short BufferGANIL::gMaskT[MAXGROUPTABLE];
		
short BufferGANIL::gMaskSE;
short BufferGANIL::gMaskSTAC;
short BufferGANIL::gMaskSP;	
short BufferGANIL::gMaskST[MAXGROUPTABLE];

short BufferGANIL::gMask[16];

unsigned short BufferGANIL::fStartSubEventTokenEXO;
unsigned short BufferGANIL::fStartSubEventTokenVAM;

using namespace gws;

#include <iostream>
#include <fstream>
using namespace std;

BufferGANIL::BufferGANIL(Memory::EEndian e, size_gw s)
{	
	fBuffer = Buffer::New(e,s);
	
	
	if ( gGroupTableECC == NULL ) {
		gGroupTableECC   = new short[gMGroupTable];	
		gGroupTableESS   = new short[gMGroupTable];	
		gGroupTableDIA   = new short[gMGroupTable];
		gGroupTableGOCCE = new short[gMGroupTable];	
		
		gGroupTableVAMOS = new short[256];
		for( short i = 0; i < 256 ; i++ ){
			gGroupTableVAMOS[i] = -1;		
		}		
		
		for( short i = 0; i < gMGroupTable ; i++ ){
			gGroupTableECC[i]   = -1;
			gGroupTableESS[i]   = -1;			
			gGroupTableDIA[i]   = -1;
			gGroupTableGOCCE[i] = -1;			
		}
		
		gNbECC = gNbESS = gNbDIA = gNbGOCCE = gNbVAMOS = 0;
		
		gItemDIAE  = gItemDIAID = gItemDIAT  = -1;
		gMaskDIAE  = gMaskDIAID = gMaskDIAT  = 0;
		
		gItemSE = gItemSTAC = gItemSP = -1;
		gMaskSE = gMaskSTAC = gMaskSP = 0;		
		for ( int i = 0; i < MAXGROUPTABLE; i++ ) { 	
			gItemSEDX0[i] = gItemSEDX1[i] = -1;
			gItemSEDY0[i] = gItemSEDY1[i] = -1; 
			gItemICHA[i]  = gItemICHB[i]  = -1;
			gItemQSED0[i] = gItemQSED1[i] = -1;
			gItemHR[i] = gItemLR[i] = gItemT[i] = gItemST[i] = -1; 
			gItemVAMOST[i] = -1;
			gMaskHR[i] = gMaskLR[i] = gMaskT[i] = gMaskST[i] =  0;	
		}	
		gItemQPLG = gItemQPLD = -1;
			
		fStartSubEventTokenEXO = 0x0001;
		fStartSubEventTokenVAM = 0x0001;
		
		for( short i = 0; i < 16 ; i++ ) {
			gMask[i] = 0;
			for( short j = 0; j < i ; j++ ) SETBIT(gMask[i],j);
		}
	}
	fIsDAQ = false;
}

BufferGANIL::~BufferGANIL()  
{ 
	if ( fBuffer ) delete fBuffer; fBuffer = NULL; 
}

bool BufferGANIL::IsType(const char *type)
{
	if ( strncmp(fBuffer->GetBuffer(),type,8)  == 0 ) return true;
	return false;
}

void BufferGANIL::InitTable(TString &tmp)
{
	char ctmp[200];
	
	int specifier, detectorid, itemid = 0, mask; 	
	sscanf(tmp.Data(),"%s %d %d",ctmp,&specifier,&mask);			
				
	detectorid = specifier & 0x00FF;	
	
	if ( tmp.Contains("CsI",TString::kIgnoreCase) ) { // DIAMANT
		for (int  i = 0; i < MAXGROUPTABLE; i++ ) {
			sprintf(ctmp,"CsI%d_",i);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { gGroupTableDIA[detectorid] = i; }
		} //i	
		if (tmp.Contains("ENERGY",TString::kIgnoreCase) ) gNbDIA++; 
		
		itemid = (specifier & 0x3F00) >> 8;
				
		if ( tmp.Contains("_ENERGY",TString::kIgnoreCase) ) { gItemDIAE  = itemid ; gMaskDIAE  = gMask[mask-1];}
		if ( tmp.Contains("_PI",TString::kIgnoreCase) )     { gItemDIAID = itemid ; gMaskDIAID = gMask[mask-1];}
		if ( tmp.Contains("_TIME",TString::kIgnoreCase)  )  { gItemDIAT  = itemid ; gMaskDIAT  = gMask[mask-1];}
	}	
	if ( tmp.Contains("ECC",TString::kIgnoreCase) ) { // GE
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			sprintf(ctmp,"ECC%d",i);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { gGroupTableECC[detectorid] = i; }
		}
		if ( tmp.Contains("_A_6MEV",TString::kIgnoreCase) ) gNbECC++;
		
		itemid = (specifier & 0x3F00) >> 8;
		
		/* \todo {URGENT !!!!!!!!!! Mettre A_6MeV etc...} */
				
		if ( tmp.Contains("6MEV",TString::kIgnoreCase) ) { 
			if ( tmp.Contains("A",TString::kIgnoreCase) ) { gItemHR[0] = itemid ; gMaskHR[0] = gMask[mask-1];}
			if ( tmp.Contains("B",TString::kIgnoreCase) ) { gItemHR[1] = itemid ; gMaskHR[1] = gMask[mask-1];}
			if ( tmp.Contains("C",TString::kIgnoreCase) ) { gItemHR[2] = itemid ; gMaskHR[2] = gMask[mask-1];}
			if ( tmp.Contains("D",TString::kIgnoreCase) ) { gItemHR[3] = itemid ; gMaskHR[3] = gMask[mask-1];}
		}
		if ( tmp.Contains("20MEV",TString::kIgnoreCase) ) { 
			if ( tmp.Contains("A",TString::kIgnoreCase) ) { gItemLR[0] = itemid ; gMaskLR[0] =  gMask[mask-1];}
			if ( tmp.Contains("B",TString::kIgnoreCase) ) { gItemLR[1] = itemid ; gMaskLR[1] =  gMask[mask-1];}
			if ( tmp.Contains("C",TString::kIgnoreCase) ) { gItemLR[2] = itemid ; gMaskLR[2] =  gMask[mask-1];}
			if ( tmp.Contains("D",TString::kIgnoreCase) ) { gItemLR[3] = itemid ; gMaskLR[3] =  gMask[mask-1];}
		}
		if ( tmp.Contains("TAC",TString::kIgnoreCase) ) { 
			if ( tmp.Contains("A",TString::kIgnoreCase) ) { gItemT[0] = itemid ; gMaskT[0] = gMask[mask-1]; }
			if ( tmp.Contains("B",TString::kIgnoreCase) ) { gItemT[1] = itemid ; gMaskT[1] = gMask[mask-1]; }
			if ( tmp.Contains("C",TString::kIgnoreCase) ) { gItemT[2] = itemid ; gMaskT[2] = gMask[mask-1]; }
			if ( tmp.Contains("D",TString::kIgnoreCase) ) { gItemT[3] = itemid ; gMaskT[3] = gMask[mask-1]; }
		}
	} // ecc
	
	if ( tmp.Contains("GOCCE",TString::kIgnoreCase) ) { // segment
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			sprintf(ctmp,"GOCCE%d",i); 
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { 
				gGroupTableGOCCE[detectorid] = i; 
				
				if ( tmp.Contains("_A_0_E",TString::kIgnoreCase) ) gNbGOCCE++;
				
				itemid = (specifier & 0x3F00) >> 8;
				if ( tmp.Contains("A",TString::kIgnoreCase) ) { // cristal A
					for (int j = 0; j < 4; j++ ) {
						sprintf(ctmp,"GOCCE%d_A_%d_E",i,j);
						if  ( tmp.Contains(ctmp,TString::kIgnoreCase) && itemid != j )
						  printf("ERROR wrong item for %s <%d>\n ",tmp.Data(),itemid);
					}
					for (int j = 0; j < 4; j++ ) {
						sprintf(ctmp,"GOCCE%d_A_%d_T",i,j);
						if  ( tmp.Contains(ctmp,TString::kIgnoreCase) && itemid != (j+4) )
						  printf("ERROR wrong item for %s <%d>\n ",tmp.Data(),itemid);	
					}	
				}
				if ( tmp.Contains("B",TString::kIgnoreCase) ) { // cristal B
					for (int j = 0; j < 4; j++ ) {
						sprintf(ctmp,"GOCCE%d_B_%d_E",i,j);
						if  ( tmp.Contains(ctmp,TString::kIgnoreCase) && itemid != (j+8) )
						  printf("ERROR wrong item for %s <%d>\n ",tmp.Data(),itemid);
	
					}
					for (int j = 0; j < 4; j++ ) {
						sprintf(ctmp,"GOCCE%d_B_%d_T",i,j);
						if  ( tmp.Contains(ctmp,TString::kIgnoreCase) && itemid != (j+12) )
						  printf("ERROR wrong item for %s <%d>\n ",tmp.Data(),itemid);	
					}	
				}
				if ( tmp.Contains("C",TString::kIgnoreCase) ) { // cristal C
					for (int j = 0; j < 4; j++ ) {
						sprintf(ctmp,"GOCCE%d_C_%d_E",i,j);
						if  ( tmp.Contains(ctmp,TString::kIgnoreCase) && itemid != (j+16) )
						  printf("ERROR wrong item for %s <%d>\n ",tmp.Data(),itemid);
	
					}
					for (int j = 0; j < 4; j++ ) {
						sprintf(ctmp,"GOCCE%d_C_%d_T",i,j);
						if  ( tmp.Contains(ctmp,TString::kIgnoreCase) && itemid != (j+20) )
						  printf("ERROR wrong item for %s <%d>\n ",tmp.Data(),itemid);	
					}	
				}
				if ( tmp.Contains("D",TString::kIgnoreCase) ) { // cristal D
					for (int j = 0; j < 4; j++ ) {
						sprintf(ctmp,"GOCCE%d_D_%d_E",i,j);
						if  ( tmp.Contains(ctmp,TString::kIgnoreCase) && itemid != (j+24) )
						  printf("ERROR wrong item for %s <%d>\n ",tmp.Data(),itemid);
	
					}
					for (int j = 0; j < 4; j++ ) {
						sprintf(ctmp,"GOCCE%d_D_%d_T",i,j);
						if  ( tmp.Contains(ctmp,TString::kIgnoreCase) && itemid != (j+28) )
						  printf("ERROR wrong item for %s <%d>\n ",tmp.Data(),itemid);	
					}	
				}
			}
		}	
	} // GOCCE
	
	if ( tmp.Contains("ESS",TString::kIgnoreCase) ) { // shield
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			sprintf(ctmp,"ESS%d",i);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { gGroupTableESS[detectorid] = i; }
		}			
		itemid = (specifier & 0x3F00) >> 8;
		
		if ( tmp.Contains("ENERGY",TString::kIgnoreCase) ) gNbESS++;
				
		if ( tmp.Contains("ENERGY",TString::kIgnoreCase) ) { gItemSE = itemid ; gMaskSE = gMask[mask-1]; }
		if ( tmp.Contains("PATTERN",TString::kIgnoreCase)) { gItemSP = itemid ; gMaskSP = gMask[mask-1]; }
		if ( tmp.Contains("TDC ",TString::kIgnoreCase) )   { gItemSTAC   = itemid; gMaskSTAC = gMask[mask-1]; }				
		if ( tmp.Contains("TDC_QA",TString::kIgnoreCase) ) { gItemST[0]   = itemid; gMaskST[0] = gMask[mask-1]; }
		if ( tmp.Contains("TDC_QB",TString::kIgnoreCase) ) { gItemST[1]   = itemid; gMaskST[1] = gMask[mask-1]; }	
		if ( tmp.Contains("TDC_QC",TString::kIgnoreCase) ) { gItemST[2]   = itemid; gMaskST[2] = gMask[mask-1]; }
		if ( tmp.Contains("TDC_QD",TString::kIgnoreCase) ) { gItemST[3]   = itemid; gMaskST[3] = gMask[mask-1]; }
	} // ess
	
	if ( tmp.Contains("TPLG_PLD",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 0; itemid = (specifier & 0x3F00) >> 8; gItemVAMOST[itemid] = 0; gNbVAMOS++;
	}
	if ( tmp.Contains("TPLG_SED0",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 0; itemid = (specifier & 0x3F00) >> 8; gItemVAMOST[itemid] = 1;gNbVAMOS++;
	}	
	if ( tmp.Contains("TPLG_SED1",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 0; itemid = (specifier & 0x3F00) >> 8; gItemVAMOST[itemid] = 2;gNbVAMOS++;
	}
	if ( tmp.Contains("TSED1_SED2",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 0; itemid = (specifier & 0x3F00) >> 8; gItemVAMOST[itemid] = 3;gNbVAMOS++;
	}					
	if ( tmp.Contains("TPLG_HF",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 0; itemid = (specifier & 0x3F00) >> 8; gItemVAMOST[itemid] = 4;gNbVAMOS++;
	}		
	if ( tmp.Contains("TSED1_HF",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 0; itemid = (specifier & 0x3F00) >> 8; gItemVAMOST[itemid] = 5;gNbVAMOS++;
	}	
	if ( tmp.Contains("TSED2_HF",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 0; itemid = (specifier & 0x3F00) >> 8; gItemVAMOST[itemid] = 6;gNbVAMOS++;
	}
	if ( tmp.Contains("TSED2_GAM",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 0; itemid = (specifier & 0x3F00) >> 8; gItemVAMOST[itemid] = 7;gNbVAMOS++;
	}	
	if ( tmp.Contains("ECHI_A",TString::kIgnoreCase) ) { // first ionisation chamber
		if ( !tmp.Contains("OLD",TString::kIgnoreCase)  ) {
		  gGroupTableVAMOS[detectorid] = 0; 
		  if ( tmp.Contains("ECHI_A_1",TString::kIgnoreCase) ) gNbVAMOS++;
		  itemid = (specifier & 0x3F00) >> 8;
		  for (int i = 1; i < MAXGROUPTABLE; i++ ) {
			sprintf(ctmp,"ECHI_A_%d",i);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase)) { 
				gItemICHA[itemid] = i-1; // printf("%s item %d %d\n",ctmp,gItemICHA[itemid], i-1);  
			}
		  }
		}
	}
	if ( tmp.Contains("ECHI_B",TString::kIgnoreCase) ) { // second ionisation chamber
		if ( !tmp.Contains("OLD",TString::kIgnoreCase)  ) {	
		  gGroupTableVAMOS[detectorid] = 0; 
		  if ( tmp.Contains("ECHI_B_1",TString::kIgnoreCase) ) gNbVAMOS++;
		  itemid = (specifier & 0x3F00) >> 8;
		  for (int i = 1; i < MAXGROUPTABLE; i++ ) {
			sprintf(ctmp,"ECHI_B_%d",i);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { 
				gItemICHB[itemid] = i-1 ; // printf("%s item %d %d\n",ctmp,gItemICHB[itemid], i-1);  
			}
		  }
		}		
	}
	if ( tmp.Contains("SED1_X",TString::kIgnoreCase) ) { // first sed X 
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			itemid = (specifier & 0x3F00) >> 8;
			sprintf(ctmp,"SED1_X_%03d",i+1);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { 
				if ( i < 64 ) { 
				//cout << tmp.Data() << "\n ---> " << detectorid << " " << itemid << " " << i-1 << endl;
					gGroupTableVAMOS[detectorid] = 1; gItemSEDX0[itemid] = i; 
				}
				else { 
				//cout << tmp.Data() << "\n ---> " << detectorid << " " << itemid+64 << " " << i-1 << endl;
					gGroupTableVAMOS[detectorid] = 2; gItemSEDX0[itemid+64] = i; 
				}
			}
		}
		if ( tmp.Contains("SED1_X_001",TString::kIgnoreCase) )gNbVAMOS++;
	}
	if ( tmp.Contains("SED1_Y",TString::kIgnoreCase) ) { // first sed Y
		gGroupTableVAMOS[detectorid] = 3; 
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			itemid = (specifier & 0x3F00) >> 8;
			sprintf(ctmp,"SED1_Y_%03d",i+1);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { gItemSEDY0[itemid] = i; }
		}		
		if ( tmp.Contains("SED1_Y_001",TString::kIgnoreCase)) gNbVAMOS++;
	}	
	if ( tmp.Contains("SED2_X",TString::kIgnoreCase) ) { //  second sed X
		// cout << tmp.Data() << endl;
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			itemid = (specifier & 0x3F00) >> 8;
			sprintf(ctmp,"SED2_X_%03d",i+1);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { 
				if ( i < 64 ) { 
				//cout << tmp.Data() << "\n ---> " << detectorid << " " << itemid << " " << i-1 << endl;
					gGroupTableVAMOS[detectorid] = 4; gItemSEDX1[itemid] = i;
				}
				else { 
				//cout << tmp.Data() << "\n ---> " << detectorid << " " << itemid+64 << " " << i-1 << endl;
					gGroupTableVAMOS[detectorid] = 5; gItemSEDX1[itemid+64] =  i; 
				}
			}
		}	
		if ( tmp.Contains("SED2_X_001",TString::kIgnoreCase)) gNbVAMOS++;
	}
	if ( tmp.Contains("SED2_Y",TString::kIgnoreCase) ) { //   second sed Y
		// cout << tmp.Data() << endl;
		gGroupTableVAMOS[detectorid] = 6; 
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			itemid = (specifier & 0x3F00) >> 8;
			sprintf(ctmp,"SED2_Y_%03d",i+1);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { gItemSEDY1[itemid] = i; }
		}		
		if ( tmp.Contains("SED2_Y_001",TString::kIgnoreCase)) gNbVAMOS++;
	}	
	if ( tmp.Contains("QSED1",TString::kIgnoreCase) ) { //   
		gGroupTableVAMOS[detectorid] = 7; 
		// printf("QSED1 \n");
		if ( tmp.Contains("QSED1_1",TString::kIgnoreCase)) gNbVAMOS++;
		itemid = (specifier & 0x3F00) >> 8;
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			sprintf(ctmp,"QSED1_%d",i+1);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) { gItemQSED0[itemid] = i; }
		}
	}
	if ( tmp.Contains("QSED2",TString::kIgnoreCase) ) { //   second sed Y
		gGroupTableVAMOS[detectorid] = 7; 
		// printf("QSED2 \n");
		if ( tmp.Contains("QSED2_1",TString::kIgnoreCase)) gNbVAMOS++;
		itemid = (specifier & 0x3F00) >> 8;
		for (int i = 0; i < MAXGROUPTABLE; i++ ) {
			sprintf(ctmp,"QSED2_%d",i+1);
			if ( tmp.Contains(ctmp,TString::kIgnoreCase) ) {  gItemQSED1[itemid] = i ; }
		}
	}
	if ( tmp.Contains("QPL_G",TString::kIgnoreCase) ) { //   
		gGroupTableVAMOS[detectorid] = 7; 
		itemid = (specifier & 0x3F00) >> 8; gItemQPLG = itemid;
	}	
	if ( tmp.Contains("QPL_D",TString::kIgnoreCase) ) { //   
		gGroupTableVAMOS[detectorid] = 7; 
		itemid = (specifier & 0x3F00) >> 8; gItemQPLD = itemid;
	}		
}

void BufferGANIL::InitTable(const char *filename) 	
{ 
	TString tmp; char ctmp[300];

	InitTable();
	cout << " try to load the group/item numbers from " << filename << endl;	
	ifstream in(filename,ios::in);	
	if ( !in ) {
		printf("Could not open %s - You cannot spy the GANIL ACQ \n",filename);
	}
	else {
		while ( 1 ) {
			in.getline(ctmp,300); 
			if ( in.gcount() > 1 ) {
				//printf("%s \n",ctmp);
				tmp = ctmp; InitTable(tmp);
			} else { break;}
		}	
	}
	SaveTable();
	cout << "   # Clovers ECC:    "  << gNbECC << endl
	     << "   # Clovers ESS:    "  << gNbESS << endl
	     << "   # Diamant CSI:    "  << gNbDIA << endl
	     << "   # Segment COCCE:  "  << gNbGOCCE << endl
	     << "   # Vamos: "           << gNbVAMOS << endl;		
}

void BufferGANIL::InitTable()
{
	for( short i = 0; i < gMGroupTable ; i++ ){
		gGroupTableECC[i]   = -1;
		gGroupTableESS[i]   = -1;			
		gGroupTableDIA[i]   = -1;
		gGroupTableGOCCE[i] = -1;			
	}
	for( short i = 0; i < 256 ; i++ ){ gGroupTableVAMOS[i] = -1; }		
		
	gNbECC = gNbESS = gNbDIA = gNbGOCCE = gNbVAMOS = 0;
		
	gItemDIAE  = gItemDIAID = gItemDIAT  = -1;
	gMaskDIAE  = gMaskDIAID = gMaskDIAT  = 0;
		
	gItemSE = gItemSTAC = gItemSP = -1;
	gMaskSE = gMaskSTAC = gMaskSP = 0;		
	for ( int i = 0; i < MAXGROUPTABLE; i++ ) { 	
		gItemSEDX0[i] = gItemSEDX1[i] = -1;
		gItemSEDY0[i] = gItemSEDY1[i] = -1; 
		gItemICHA[i]  = gItemICHB[i]  = -1;
		gItemQSED0[i] = gItemQSED1[i] = -1;
		gItemHR[i] = gItemLR[i] = gItemT[i] = gItemST[i] = -1; 
		gMaskHR[i] = gMaskLR[i] = gMaskT[i] = gMaskST[i] =  0;	
	}		
}

void BufferGANIL::InitTable(Buffer *b)
{
	TString tmp;
	// read the buffer and creat the list of parameters
	b->SetOffset(12);

	tmp = ""; char c;
	
	ofstream out1("bufferGANIL.parameter",ios::out | ios::app);	
	for( size_gw i = 0; i < b->Size()-12; i++ ) {
		(*b) >> c; tmp += c;
		if ( c == 0x0D ) {
			tmp.ReplaceAll(","," "); InitTable(tmp); out1 << tmp.Data() << endl ;
			tmp = ""; 
		} // c
	} // i
	out1.close(); SaveTable();
}

void BufferGANIL::SaveTable(const char *filename)
{
	ofstream out2(filename,ios::out);	
	
	for( int i = 0; i < gMGroupTable; i++){
		if ( gGroupTableECC[i] != -1 ) {
			out2 << "ECC VXI " << i << " , DET " << gGroupTableECC[i] << endl;
		}
		if ( gGroupTableESS[i] != -1 ) {
			out2 << "ESS VXI " << i << " , DET " << gGroupTableESS[i] << endl;		
		}
		if ( gGroupTableGOCCE[i] != -1 ) {
			out2 << "GOCCE VXI " << i << " , DET " << gGroupTableGOCCE[i] << endl;		
		}		
		if ( gGroupTableDIA[i] != -1 ) {
			out2 << "DIAMANT VXI " << i << " , DET " << gGroupTableDIA[i] << endl;
		}	
		if ( gGroupTableVAMOS[i] != -1 ) {
			out2 << "VAMOS VXI " << i << " , DET " << gGroupTableVAMOS[i] << endl;
		}	
			
	} 
	if ( gNbDIA > 0 ) 
		out2 << "ITEM DIAMANT - E " << gItemDIAE << " ID " << gItemDIAID << " TAC " << gItemDIAT << endl;
		out2 << "MASK DIAMANT - E " << gMaskDIAE << " ID " << gMaskDIAID << " TAC " << gMaskDIAT << endl;

	if ( gNbECC > 0 ) {
		for( int i = 0; i < NBCRIS; i++){
			out2 << "ITEM ECC #" << i << " - EHR " << gItemHR[i] << " ELR " 
			     << gItemLR[i] << " TAC " << gItemT[i] << endl;
			out2 << "MASK ECC #" << i << " - EHR " << gMaskHR[i] << " ELR " 
			     << gMaskLR[i] << " TAC " << gMaskT[i] << endl;			     
		}
	}	
	if ( gNbESS > 0 ) {
		out2 << "ITEM ESS - E " << gItemSE << " TAC " << gItemSTAC << " PATTERN " << gItemSP << endl;
		out2 << "ITEM ESS - T SINGLE " 
		     << gItemST[0] << " " << gItemST[1] << " " << gItemST[2] << " " << gItemST[3] << endl;
		out2 << "MASK ESS - E " << gMaskSE << " TAC " << gMaskSTAC << " PATTERN " << gMaskSP << endl;
		out2 << "MASK ESS - T SINGLE " 
		     << gMaskST[0] << " " << gMaskST[1] << " " << gMaskST[2] << " " << gMaskST[3] << endl;		     
	}
	if ( gNbVAMOS > 0 ) {
		for ( int i = 0; i < MAXGROUPTABLE; i++ ) {
			if ( gItemICHA[i] != -1 ) out2 << i << "  for me, ICH0 " << gItemICHA[i] << endl;
			if ( gItemICHB[i] != -1 ) out2 << i << " item ICH1 " << gItemICHB[i] << endl;
			if ( gItemVAMOST[i] != -1 ) out2 << i << " item time " << gItemVAMOST[i] << endl;
			if ( gItemQSED0[i]  != -1 ) out2 << i << " item QSED0 " << gItemQSED0[i] << endl;
			if ( gItemQSED1[i]  != -1 ) out2 << i << " item QSED1 " << gItemQSED1[i] << endl;	
			if ( gItemSEDY0[i]  != -1 ) out2 << i << " item SED1Y " << gItemSEDY0[i] << endl;
			if ( gItemSEDY1[i]  != -1 ) out2 << i << " item SED1Y " << gItemSEDY1[i] << endl;	
		}
	}	
	out2 << " GE: " << gNbECC << ", Shield: " << gNbESS 
	     << ", Diamant: " << gNbDIA << ", Gocce: " << gNbGOCCE 
	     << ", VAMOS: " << gNbVAMOS << endl;
	     
	out2.close();
}
	
bool BufferGANIL::InitReading()
{
	int magic = 0; bool ok = false;

	if ( fIsDAQ ) {
		fBuffer->SetOffset(0);
		(*fBuffer) >> magic;
		if ( magic != 0x22061999 ) printf("WARNING WRONG byte ordering for input buffer %x \n",magic);				
		fBuffer->SetOffset(10);			
		(*fBuffer) >> fNbEvents;
		//printf(" events %d \n",fNbEvents);	
		fBuffer->SetOffset(16);
		(*fBuffer) >> fEventsSize;
		//printf(" events size %d \n",fEventsSize);
		fBuffer->SetOffset(20); 
		fNbEventsR = 0; fEventsSizeR = 0;  return true;	
	}
	
	fBuffer->SetOffset(0); 	
	if ( IsType(" FILEH  ") ) {
		printf(" Header file block, set DAQ parameters to 0 \n"); InitTable();
	}	
	if ( IsType(" COMMENT") ) {
		// printf("Comment block \n ");
	}	
	if ( IsType(" PARAM  ") ) {
		printf("Parameters block, re-initialisation of DAQ parameters \n"); 
		InitTable(fBuffer);
		cout << "   # Clovers ECC:    "  << gNbECC << endl
		     << "   # Clovers ESS:    "  << gNbESS << endl
	             << "   # Diamant CSI:    "  << gNbDIA << endl
		     << "   # Segment COCCE: "  << gNbGOCCE << endl
		     << "   # Vamos: "  << gNbVAMOS << endl;		     
	}	
	if ( IsType(" EVENTH ") ) {
		strncpy(fDate,fBuffer->GetBuffer()+37,19);  // new date
		char tmp[6]; 
		strncpy(tmp,fBuffer->GetBuffer()+62,6); sscanf(tmp,"%d",&fRun); // new run
		printf("Data block, NEW RUN # %d, written at %s \n",fRun,fDate);
	}
	if ( IsType(" EBYEDAT") ) {
		// read some informations from the block header
		// printf("BLOCK HEADER \n");
		fBuffer->SetOffset(8);
		(*fBuffer) >> fBlock;
		//printf(" block %d \n",fBlock);		
		(*fBuffer) >> magic;
		if ( magic != 0x22061999 ) printf("WARNING WRONG byte ordering for input buffer %x \n",magic);	
		fBuffer->SetOffset(22);			
		(*fBuffer) >> fNbEvents;
		//printf(" events %d \n",fNbEvents);	
		fBuffer->SetOffset(28);
		(*fBuffer) >> fEventsSize;
		//printf(" events size %d \n",fEventsSize);
		fBuffer->SetOffset(32); 
		fNbEventsR = 0; fEventsSizeR = 0; ok = true;
/*		for ( int i = 0; i < 200; i++ ) {
			(*fBuffer) >> test1;
			printf("%x \n",test1);
		} */
	}
	return ok;
}

unsigned short * BufferGANIL::NextEvent(unsigned short &event_size)
{	
	unsigned short start_token = 0;
	
	event_size = 0;
	// end of buffer	
	if ( fBuffer->FreeSize() == 0 ) { 
		if ( fNbEventsR != fNbEvents || fEventsSizeR != fEventsSize ) {
//		  printf("Pb when reading block # %d (%d) \n",fBlock,fBuffer->FreeSize());		
		  printf("Pb when reading block # %d, no end of block \n",fBlock);
		  printf("Events read %d <%d>, size %d <%d> \n ",fNbEventsR,fNbEvents,fEventsSizeR,fEventsSize);
		}
		return NULL; 
	}
	
	// check if end event token
	(*fBuffer) >> start_token ;
	if ( start_token != fStartEventToken ) { 
		if ( start_token == fEndDataBlockToken ) fEventsSizeR += 2;
		if ( fNbEventsR != fNbEvents || fEventsSizeR != fEventsSize ) {
		  printf("Pb when reading block # %d (%d) \n",fBlock,fBuffer->FreeSize());
		  printf("Events read %d <%d>, size %d <%d> \n ",fNbEventsR,fNbEvents,fEventsSizeR,fEventsSize);
		}	
		return NULL; 
	}
//	printf("OK \n");
	(*fBuffer) >> event_size; event_size -= 2;
//	printf("event size %d \n",event_size);
	
	for(unsigned short i = 0; i < event_size; i++ ){ (*fBuffer) >> fEvent[i]; }
	
	fNbEventsR++; fEventsSizeR += (event_size+2);
//	printf("still to read %d \n",fBuffer->FreeSize());	
	return fEvent;
//	return NULL;
}

/*
bool IsEndian(gws::Memory::EEndian e) 
{
    int magic = (int *)(data+12);

    fBuffer->SetOffset(12); (*fBuffer) >> magic;
    if ( magic == 0x22061999 ) {
	
    }
    else {
	fIsSwap = kTRUE; SysMEMORY::Swap(fBuffer,data,length);
    }
}
*/


