////////////////////////////////////////////////////////////////////////////////
//									                                  //
//									                                  //
////////////////////////////////////////////////////////////////////////////////


#include <TClass.h>
#include <TROOT.h>
#include <TFile.h>

#include "BufferGANIL.h"
#include "Event.h"

ClassImp(RawEvent);
RawEvent::RawEvent() { 

	RawEvent::Class()->IgnoreTObjectStreamer(); 
}
RawEvent::~RawEvent() { ; }

ClassImp(CellCsI);

CellCsI::CellCsI() { CellCsI::Class()->IgnoreTObjectStreamer(); }
CellCsI::~CellCsI() { ;}

ClassImp(DiamantR);

DiamantR::DiamantR() 
{ 
	Cells = new TClonesArray("CellCsI",56); NbCell = 0;
	DiamantR::Class()->IgnoreTObjectStreamer();
}

DiamantR::~DiamantR() 
{
	Cells->Delete(); delete Cells; Cells = NULL;	
}

void DiamantR::Clear(Option_t *opt)
{
	Cells->Clear(opt); NbCell = 0;
}


Bool_t DiamantR::Fill(UShort_t *data_stream, UShort_t data_stream_length) 
{
	CellCsI *cell;
	
	// detector id says to what familly of detector belongs the following data_stream
	// item id says what is coded: energy, tac ... 
	UShort_t subtoken, sublength, detectorid, itemid;
	UShort_t specifier, data;
	
//	printf("in Fill Diam\n");
        Clear("C");	
	TClonesArray &ar = *Cells;
	
	UShort_t link[256]; ::memset(link,0,512);
	// UShort_t w[256]; UShort_t w[256]; UShort_t w[256]; UShort_t w[256];
	//::memset(link,0,512);
	
	
	NbCell = 0; UShort_t pos = 3;
	while ( pos < data_stream_length ) {
//		cout << "subevent token :" << fBuffer[fPos] << endl;
		subtoken = data_stream[pos++];
		// if ( subtoken != fStartSubEventToken ) printf("WRONG sub event token %x \n",subtoken);

//		cout << "subevent length :" << fBuffer[fPos] << endl;

		sublength = ( data_stream[pos++] - 2 )/2;
		// printf("subevent length : %d \n ",sublength); 

		for (UShort_t  i = 0; i < sublength; i++) {
		        specifier = data_stream[pos++]; data = data_stream[pos++];

			detectorid = specifier & 0x00FF; 
						
			if ( BufferGANIL::gGroupTableDIA[detectorid] != -1 ) {
				// printf("detector id %d %d \n",detectorid,BufferGANIL::gGroupTableDIA[detectorid]);

				itemid = (specifier & 0x3F00) >> 8;  
						
				if ( link[BufferGANIL::gGroupTableDIA[detectorid]] == 0 ) {
					//printf("get new %d \n ",detectorid);
					link[BufferGANIL::gGroupTableDIA[detectorid]] = NbCell+1;	
					cell = new( ar[NbCell] ) CellCsI();
					NbCell++;
					// cell->SetWhich(BufferGANIL::gGroupTableDIA[detectorid]);
					cell->Which = BufferGANIL::gGroupTableDIA[detectorid] ;
				}
				else {
					//printf("get old at position %d \n ",link[BufferGANIL::gGroupTableDIA[detectorid]]-1);				
					cell = new( ar[link[BufferGANIL::gGroupTableDIA[detectorid]]-1] ) CellCsI();
					// c->SetWhich(gGroupTableC[detectorid]);
				}
				//cell = new( ar[NbCell++] ) CellCsI();
				
				//printf("Diam %d %d \n",itemid,data);
				switch ( itemid ) {
					case 0:
						// printf("Diam %d %d \n",itemid,data);cell->SetEnergy(data);
						 //printf("Diam %d %d \n",itemid,data);
						 cell->Energy = data;
						 //printf("Get Energy Diam %d \n",cell->Energy);
					break;
					case 1:
						//printf("Diam %d %d \n",itemid,data);cell->SetId(data);
						 //printf("Diam %d %d \n",itemid,data);
						 cell->Id = data;
					break;
					case 2:					
						//printf("Diam %d %d \n",itemid,data);cell->SetTime(data);
						 //printf("Diam %d %d \n",itemid,data);
						 cell->Time = data;
					break;					
					default:
						if (gDebug > 0 ) printf("PB storing item %d in Diamant \n",itemid);
					break;
				}
				//if ( itemid == 0 ) { cell->SetEnergy(data & 0x3FFF);}
				//if ( itemid == BufferGANIL::gItemDIAE ) { cell->SetEnergy(data & 0x1FFF);}				
				//if ( itemid == 1 ){ cell->SetId(data & 0x3FFF);}
				//if ( itemid == 2 ) { cell->SetTime(data & 0x3FFF); }
			}
		}
	}
/*	if ( NbCell > 0 ) {
	  printf("NbCell %d \n",NbCell); 
	  ar.ls();
	  cell = (CellCsI *) ar[0]; cell->ls("");
	} */
	
	if ( NbCell > 0 ) return kTRUE;
	return kFALSE;
}	

ClassImp(ExoClover);

ExoClover::ExoClover() { ExoClover::Class()->IgnoreTObjectStreamer();; }
ExoClover::ExoClover(const ExoClover &clover) {
	Which = clover.Which; 
	ShieldE = clover.ShieldE;
	ShieldT = clover.ShieldT;
	ShieldP = clover.ShieldP;

	Time[0] = clover.Time[0];
	Time[1] = clover.Time[1];
	Time[2] = clover.Time[2];
	Time[3] = clover.Time[3];
	
	EnergyHR[0] = clover.EnergyHR[0];
	EnergyHR[1] = clover.EnergyHR[1];
	EnergyHR[2] = clover.EnergyHR[2];
	EnergyHR[3] = clover.EnergyHR[3];
	
	EnergyLR[0] = clover.EnergyLR[0];
	EnergyLR[1] = clover.EnergyLR[1];
	EnergyLR[2] = clover.EnergyLR[2];
	EnergyLR[3] = clover.EnergyLR[3];
	

	PileUp[0] = clover.PileUp[0];
	PileUp[1] = clover.PileUp[1];
	PileUp[2] = clover.PileUp[2];
	PileUp[3] = clover.PileUp[3];
	Compton[0] = clover.Compton[0];
	Compton[1] = clover.Compton[1];
	Compton[2] = clover.Compton[2];
	Compton[3] = clover.Compton[3];

	TimeS[0] = clover.TimeS[0];
	TimeS[1] = clover.TimeS[1];
	TimeS[2] = clover.TimeS[2];
	TimeS[3] = clover.TimeS[3];
	
	GocceE[0][0] = clover.GocceE[0][0];
	GocceE[0][1] = clover.GocceE[0][1];
	GocceE[0][2] = clover.GocceE[0][2];
	GocceE[0][3] = clover.GocceE[0][3];
	
	GocceE[1][0] = clover.GocceE[1][0];
	GocceE[1][1] = clover.GocceE[1][1];
	GocceE[1][2] = clover.GocceE[1][2];
	GocceE[1][3] = clover.GocceE[1][3];
	
	GocceE[2][0] = clover.GocceE[2][0];
	GocceE[2][1] = clover.GocceE[2][1];
	GocceE[2][2] = clover.GocceE[2][2];
	GocceE[2][3] = clover.GocceE[2][3];
	
	GocceE[3][0] = clover.GocceE[3][0];
	GocceE[3][1] = clover.GocceE[3][1];
	GocceE[3][2] = clover.GocceE[3][2];
	GocceE[3][3] = clover.GocceE[3][3];
	
	GocceT[0][0] = clover.GocceT[0][0];
	GocceT[0][1] = clover.GocceT[0][1];
	GocceT[0][2] = clover.GocceT[0][2];
	GocceT[0][3] = clover.GocceT[0][3];
	
	GocceT[1][0] = clover.GocceT[1][0];
	GocceT[1][1] = clover.GocceT[1][1];
	GocceT[1][2] = clover.GocceT[1][2];
	GocceT[1][3] = clover.GocceT[1][3];
	
	GocceT[2][0] = clover.GocceT[2][0];
	GocceT[2][1] = clover.GocceT[2][1];
	GocceT[2][2] = clover.GocceT[2][2];
	GocceT[2][3] = clover.GocceT[2][3];
	
	GocceT[3][0] = clover.GocceT[3][0];
	GocceT[3][1] = clover.GocceT[3][1];
	GocceT[3][2] = clover.GocceT[3][2];
	GocceT[3][3] = clover.GocceT[3][3];
	
	
}
ExoClover::~ExoClover() { ; }

ClassImp(ExogamR);
		
ExogamR::ExogamR() 
{ 
	Clovers = new TClonesArray("ExoClover",MAXCLOVER); NbClover = 0;
	ExogamR::Class()->IgnoreTObjectStreamer();
}

ExogamR::~ExogamR() 
{
	Clovers->Delete(); delete Clovers; Clovers = NULL;	
}

void ExogamR::Clear(Option_t *opt)
{
	Clovers->Clear(opt); NbClover = 0;
}

Bool_t ExogamR::Fill(UShort_t *data_stream, UShort_t data_stream_length) 
{	
	ExoClover *clover; Bool_t ok;
	// detector id says to what familly of detector belongs the following data_stream
	// item id says what is coded: energy, tac ... 
	UShort_t subtoken, sublength, detectorid, itemid;
	UShort_t specifier, data;
	
	Clear("C");
	TClonesArray &ar = *Clovers; 
	UShort_t link[256]; ::memset(link,0,512);
	

	ok = kFALSE; UShort_t pos = 3;
//	printf("EXOGAM data_stream_length %d \n",data_stream_length);
	while ( pos < data_stream_length ) {

		subtoken = data_stream[pos++];
		//if ( loop < 10) cout << "subevent token :" << data_stream[pos] << endl;		
		// if ( subtoken != fStartSubEventToken ) printf("WRONG sub event token %x \n",subtoken);

		sublength = ( data_stream[pos++] - 2 )/2;
		// printf("subevent length : %d \n ",sublength); 

		for (UShort_t  i = 0; i < sublength; i++) {
	
			//if ( l < 10) printf("Start subevent %d %d\n ",i,sublength);
		        specifier = data_stream[pos++]; data = data_stream[pos++];
			
			//if ( loop < 10) printf(" specifier %d data %d\n ",i,sublength);
			detectorid = specifier & 0x00FF;

			if ( BufferGANIL::gGroupTableECC[detectorid] != -1 ) { // clover GE detector
			
				ok = kTRUE;
				
				itemid = (specifier & 0x3F00) >> 8; // fItemDistribution->Fill(itemid); 
						
				if ( link[BufferGANIL::gGroupTableECC[detectorid]] == 0 ) {
					// printf("get new GE %d \n ",BufferGANIL::gGroupTableECC[detectorid]);
					link[BufferGANIL::gGroupTableECC[detectorid]] = NbClover+1;		
					clover = new( ar[NbClover++] ) ExoClover();
					//clover->Clear("");
					clover->Which = BufferGANIL::gGroupTableECC[detectorid];
				}
				else {
					// printf("get old at position GE %d \n ",link[BufferGANIL::gGroupTableECC[detectorid]]-1);				
					clover = new( ar[link[BufferGANIL::gGroupTableECC[detectorid]]-1] ) ExoClover();
					//clover->SetWhich(gGroupTableC[detectorid]);
				}
				//printf("item GEHR0 %d \n ",itemid);
				if ( itemid == BufferGANIL::gItemHR[0] ) {
					if ( TESTBIT(specifier,15) ) clover->PileUp[0] = kTRUE;
					if ( TESTBIT(specifier,14) ) clover->Compton[0] = kTRUE;	
					clover->EnergyHR[0] = data & 0x3FFF;
				}
				//printf("item GEHR1 %d \n ",itemid);				
				if ( itemid == BufferGANIL::gItemHR[1] ) {
					if ( TESTBIT(specifier,15) ) clover->PileUp[1] = kTRUE;
					if ( TESTBIT(specifier,14) ) clover->Compton[1] =  kTRUE;	
					clover->EnergyHR[1] = data & 0x3FFF; 		
				}
				//printf("item GEHR2 %d \n ",itemid);				
				if ( itemid == BufferGANIL::gItemHR[2] ) {
					if ( TESTBIT(specifier,15) ) clover->PileUp[2] = kTRUE;
					if ( TESTBIT(specifier,14) ) clover->Compton[2]= kTRUE;
					clover->EnergyHR[2] = data & 0x3FFF;			
				}
				//printf("item GEHR3 %d \n ",itemid);				
				if ( itemid == BufferGANIL::gItemHR[3] ) {
					if ( TESTBIT(specifier,15) ) clover->PileUp[3] = kTRUE;
					if ( TESTBIT(specifier,14) ) clover->Compton[3] = kTRUE;	
					clover->EnergyHR[3] = data & 0x3FFF; 				
				}
				//printf("item GELR %d \n ",itemid);								
				if ( itemid == BufferGANIL::gItemLR[0] ) { clover->EnergyLR[0] = data & 0x3FFF; }
				if ( itemid == BufferGANIL::gItemLR[1] ) { clover->EnergyLR[1] = data & 0x3FFF; }
				if ( itemid == BufferGANIL::gItemLR[2] ) { clover->EnergyLR[2] = data & 0x3FFF; }
				if ( itemid == BufferGANIL::gItemLR[3] ) { clover->EnergyLR[3] = data & 0x3FFF; }
				//printf("item GELR %d \n ",itemid);																
				if ( itemid == BufferGANIL::gItemT[0] ) { clover->Time[0] = data & 0x7FFF;}
				if ( itemid == BufferGANIL::gItemT[1] ) { clover->Time[1] = data & 0x7FFF; }
				if ( itemid == BufferGANIL::gItemT[2] ) { clover->Time[2] = data & 0x7FFF; }
				if ( itemid == BufferGANIL::gItemT[3] ) { clover->Time[3] = data & 0x7FFF;}
			} // clover
			
			if ( BufferGANIL::gGroupTableESS[detectorid] != -1 ) { // shield detector
			
				itemid = (specifier & 0x3F00) >> 8; // fItemDistribution->Fill(itemid); 
						
				if ( link[BufferGANIL::gGroupTableESS[detectorid]] == 0 ) {
					//printf("get new ESS %d \n ",detectorid);
					link[BufferGANIL::gGroupTableESS[detectorid]] = NbClover+1;	
					clover = new( ar[NbClover++] ) ExoClover();
					clover->Which = BufferGANIL::gGroupTableESS[detectorid];
				}
				else {
					//printf("get old at position ESS %d \n ",link[BufferGANIL::gGroupTableESS[detectorid]]-1);				
					clover = new( ar[link[BufferGANIL::gGroupTableESS[detectorid]]-1] ) ExoClover();
					//clover->SetWhich(gGroupTableC[detectorid]);
				}
				if ( itemid == BufferGANIL::gItemSE )   { clover->ShieldE = data & 0x0FFF;}
				if ( itemid == BufferGANIL::gItemSP )   { clover->ShieldP = data & 0x0FFF;}
				if ( itemid == BufferGANIL::gItemSTAC)  { clover->ShieldT = data & 0x0FFF;}
			} // shield
			
			if ( BufferGANIL::gGroupTableGOCCE[detectorid] != -1 ) { // GOCCE
					
				if ( link[BufferGANIL::gGroupTableGOCCE[detectorid]] == 0 ) {
					// printf("get new GOCCE %d \n ",detectorid);
					link[BufferGANIL::gGroupTableGOCCE[detectorid]] = NbClover+1;	
					clover = new( ar[NbClover++] ) ExoClover();
					clover->Which = BufferGANIL::gGroupTableGOCCE[detectorid] ;
				}
				else {
					// printf("get old GOCCE at position %d \n ",link[BufferGANIL::gGroupTableGOCCE[detectorid]]-1);				
					clover = new( ar[link[BufferGANIL::gGroupTableGOCCE[detectorid]]-1] ) ExoClover();
					//clover->SetWhich(gGroupTableC[detectorid]);
				}
				itemid = (specifier & 0x3F00) >> 8;
				
				switch( itemid / 8  ){
					case 0:
						// cristal A
						if ( (itemid % 8) < 4 ) clover->GocceE[0][itemid % 8] = data & 0x3FFF;
						else clover->GocceT[0][(itemid%8)-4] = data & 0x3FFF;	
					break;
					case 1:
						// cristal B
						if ( (itemid % 8) < 4 ) clover->GocceE[1][itemid % 8] = data & 0x3FFF;
						else clover->GocceT[1][(itemid%8)-4] = data & 0x3FFF;		
					break;	
					case 2:
						// cristal C					
						if ( (itemid % 8) < 4 ) clover->GocceE[2][itemid % 8] = data & 0x3FFF;
						else clover->GocceT[2][(itemid%8)-4] = data & 0x3FFF;	
					break;
					case 3:
						// cristal D					
						if ( (itemid % 8) < 4 ) clover->GocceE[3][itemid % 8] = data & 0x3FFF;
						else clover->GocceT[3][(itemid%8)-4] = data & 0x3FFF;
					break;	
					default:
						if (gDebug > 0 )  printf("Wrong item %d for GOCCE # %d \n",itemid,BufferGANIL::gGroupTableGOCCE[detectorid]);
					break;
				} // switch	
			}	
			
		} // i
	} // pos
	
//	printf("NbClover %d \n",NbClover);
//	return kTRUE;
//	return ok;
	
	if ( NbClover > 0 ) return kTRUE;
	return kFALSE;
}
	
ClassImp(VariableArrayF);

VariableArrayF::VariableArrayF()
{
	Mult = 0; ::memset(Data,0,100*sizeof(Float_t));
	
	VariableArrayF::Class()->IgnoreTObjectStreamer();
}

VariableArrayF::~VariableArrayF()
{
;
}

void VariableArrayF::Clear(Option_t *opt)
{
	Mult = 0; ::memset(Data,0,100*sizeof(Float_t));
}	


ClassImp(GammaTheta);

GammaTheta::GammaTheta()
{
	Mult = 0; ::memset(Energy,0,100*sizeof(Float_t));  ::memset(Theta,0,100*sizeof(Float_t));
	
	GammaTheta::Class()->IgnoreTObjectStreamer();
}

GammaTheta::~GammaTheta()
{
;
}

void GammaTheta::Clear(Option_t *opt)
{
	Mult = 0; ::memset(Energy,0,100*sizeof(Float_t));  ::memset(Theta,0,100*sizeof(Float_t));
} 

ClassImp(BetaF);

BetaF::BetaF()
{
	Beta = 0;
	BetaF::Class()->IgnoreTObjectStreamer();
}

BetaF::~BetaF()
{
;
}

void BetaF::Clear(Option_t *opt)
{
	Beta = 0;
} 

ClassImp(GammaTAC);

GammaTAC::GammaTAC()
{
	Mult = 0; ::memset(Energy,0,100*sizeof(Float_t));  ::memset(TAC,0,100*sizeof(UShort_t));  ::memset(Theta,0,100*sizeof(Float_t)); ::memset(Phi,0,100*sizeof(Float_t));

	GammaTAC::Class()->IgnoreTObjectStreamer();
}

GammaTAC::~GammaTAC()
{
;
}

void GammaTAC::Clear(Option_t *opt)
{
	Mult = 0; ::memset(Energy,0,100*sizeof(Float_t));  ::memset(TAC,0,100*sizeof(UShort_t));   ::memset(Theta,0,100*sizeof(Float_t)); ::memset(Phi,0,100*sizeof(Float_t));
} 


ClassImp(LCP);

LCP::LCP()
{
	Proton = 0; Alpha = 0; Radioactivity1 = 0 ; Radioactivity2=0 ; Others = 0 ; 

	LCP::Class()->IgnoreTObjectStreamer();
}

LCP::~LCP()
{
;
}

void LCP::Clear(Option_t *opt)
{
	Proton = 0; Alpha = 0; Radioactivity1 = 0 ; Radioactivity2=0 ; Others = 0 ;
} 



ClassImp(Pad);
ClassImp(VamosR);

VamosR::VamosR()
{
	ICH0  = new TClonesArray("Pad",MAXICH); NbICH[0] = 0 ;
	ICH1  = new TClonesArray("Pad",MAXICH); NbICH[1] = 0  ;	

	SED0X = new TClonesArray("Pad",MAXSEDX); NbSEDX[0] = 0  ;	//-> SED 1X	
	SED1X = new TClonesArray("Pad",MAXSEDX); NbSEDX[1] = 0  ;	//-> SED 2X	
	SED0Y = new TClonesArray("Pad",MAXSEDY); NbSEDY[0] = 0  ;	//-> SED 1Y	
	SED1Y = new TClonesArray("Pad",MAXSEDY); NbSEDY[1] = 0  ;	//-> SED 2Y
	
	/*
	TDirectory *old = gDirectory;
	// look for the file name RawToTreeHist.root
	TFile *f = (TFile *)gROOT->GetListOfFiles()->FindObject("RawToTreeHist.root");
	if ( f == NULL ) f = new TFile("RawToTreeHist.root","UPDATE");
	
	f->cd();
	fGroupDistribution = new TH1D("Vamos_group","GroupDistribution",256,0,256);
	fItemSED0X = new TH1D("SED0X","ItemDistribution",MAXSEDX,0,MAXSEDX);
	fItemSED0Y = new TH1D("SED0Y","ItemDistribution",MAXSEDY,0,MAXSEDY);		//!	
	fItemSED1X = new TH1D("SED1X","ItemDistribution",MAXSEDX,0,MAXSEDX);		//!	
	fItemSED1Y = new TH1D("SED1Y","ItemDistribution",MAXSEDY,0,MAXSEDY);		//!
	old->cd();
	*/
	VamosR::Class()->IgnoreTObjectStreamer();	
}

VamosR::~VamosR()
{
	ICH0->Delete(); delete ICH0; ICH0= NULL;
	ICH1->Delete(); delete ICH1 ; ICH1= NULL;
	SED0X->Delete(); delete SED0X; SED0X= NULL;
	SED1X->Delete();  delete SED1X;	SED1X= NULL;
	SED0Y->Delete(); delete  SED0Y; SED0Y= NULL;
	SED1Y->Delete(); delete  SED1Y;	SED1Y= NULL;
	
	// delete fGroupDistribution; delete fItemSED0X; delete fItemSED0Y; delete fItemSED1X; delete fItemSED1Y;
}

void VamosR::Clear(Option_t *opt)
{
	ICH0->Clear(opt);  NbICH[0] = 0;
	ICH1->Clear(opt);  NbICH[1] = 0;
	SED0X->Clear(opt); NbSEDX[0] = 0;	
	SED1X->Clear(opt); NbSEDX[1] = 0;	
	SED0Y->Clear(opt); NbSEDY[0] = 0;
	SED1Y->Clear(opt); NbSEDY[1] = 0;
	
	QSED0[0] = QSED0[1] = QSED0[2] = 0;	
	QSED1[0] = QSED1[1] = QSED1[2] = 0;	
	
	TSED0_HF = TSED1_HF = 0;
	
	TPLG_PLD = TPLG_SED0 = TPLG_SED1 = TSED0_SED1 = TPLG_HF = TSED2_GAM = 0;
	
	QPL_G = QPL_D = 0;
}

Bool_t VamosR::Fill(UShort_t *data_stream, UShort_t data_stream_length)
{
	Pad *pad; Bool_t ok;
	// detector id says to what familly of detector belongs the following data_stream
	// item id says what is coded: energy, tac ... 
	UShort_t subtoken, sublength, detectorid, itemid;
	UShort_t specifier, data;
	
	Clear("C"); // no need to clear individual pad, only one ADC
	
	TClonesArray &arICH0 = *ICH0; 
	TClonesArray &arICH1 = *ICH1; 	
	TClonesArray &arSED0X = *SED0X;
	TClonesArray &arSED1X = *SED1X;
	TClonesArray &arSED0Y = *SED0Y;
	TClonesArray &arSED1Y = *SED1Y;

	UShort_t pos = 3; ok = kFALSE;
	
	// printf("VAMOS data_stream_length %d \n",data_stream_length);
	
	while ( pos < data_stream_length ) {
	
		subtoken = data_stream[pos++];
		//cout << "subevent token VAMOS :" << data_stream[pos] << endl;		
		// if ( subtoken != fStartSubEventToken ) printf("WRONG sub event token %x \n",subtoken);

//		cout << "subevent length :" << fBuffer[fPos] << endl;

		sublength = ( data_stream[pos++] - 2 )/2;
		// printf("subevent length : %d \n ",sublength); 

		for (UShort_t  i = 0; i < sublength; i++) {
		
		        specifier = data_stream[pos++]; data = data_stream[pos++];

			detectorid = specifier & 0x00FF; 
			// if ( specifier == 773 ) printf(" TAC %d \n",data & 0x3FFF);

			if ( BufferGANIL::gGroupTableVAMOS[detectorid] != -1 ) {
			
				itemid = (specifier & 0x3F00) >> 8;
				
				//printf("Vamos did %d %d \n",detectorid,BufferGANIL::gGroupTableVAMOS[detectorid]);
				
				switch ( BufferGANIL::gGroupTableVAMOS[detectorid] ) {
					case 0:
						// printf("Case 0 \n");
						if ( BufferGANIL::gItemVAMOST[itemid] == 0 ) { TPLG_PLD  = data & 0x3FFF;}
						if ( BufferGANIL::gItemVAMOST[itemid] == 1 ) { TPLG_SED0 = data & 0x3FFF;}
						if ( BufferGANIL::gItemVAMOST[itemid] == 2 ) { TPLG_SED1 = data & 0x3FFF;}
						if ( BufferGANIL::gItemVAMOST[itemid] == 3 ) { 
							TSED0_SED1 = data & 0x3FFF;
							if ( TSED0_SED1 > 1000 ) ok = kTRUE; 
						}
						if ( BufferGANIL::gItemVAMOST[itemid] == 4 ) { TPLG_HF   = data & 0x3FFF;}
						if ( BufferGANIL::gItemVAMOST[itemid] == 5 ) { TSED0_HF  = data & 0x3FFF;}
						if ( BufferGANIL::gItemVAMOST[itemid] == 6 ) { TSED1_HF  = data & 0x3FFF;}
						if ( BufferGANIL::gItemVAMOST[itemid] == 7 ) { TSED2_GAM  = data & 0x3FFF;}						
						if ( BufferGANIL::gItemICHA[itemid] != -1 ) {
						    pad = new( arICH0[NbICH[0]++] ) Pad();
						    pad->Q = data & 0x3FFF; pad->Which = BufferGANIL::gItemICHA[itemid];
						}
						if ( BufferGANIL::gItemICHB[itemid] != -1 ) {
						    pad = new( arICH1[NbICH[1]++] ) Pad();
						    pad->Q = data & 0x3FFF ; pad->Which = BufferGANIL::gItemICHB[itemid];
						}
					break;
					case 1:
						//printf("Case 1 \n");	
						//fItemSED0X->Fill(BufferGANIL::gItemSEDX0[itemid]);
						pad = new( arSED0X[NbSEDX[0]++] ) Pad();
						pad->Q = data & 0x0FFF; pad->Which = BufferGANIL::gItemSEDX0[itemid];
					break;					
					case 2:
						//printf("Case 2 \n");
						//fItemSED0X->Fill(BufferGANIL::gItemSEDX0[itemid+64]);	
						pad = new( arSED0X[NbSEDX[0]++] ) Pad();
						pad->Q = data & 0x0FFF; pad->Which = BufferGANIL::gItemSEDX0[itemid+64];
					break;	
					case 3:
						//printf("Case 3 \n");
						//fItemSED0Y->Fill(BufferGANIL::gItemSEDY0[itemid]);
						pad = new( arSED0Y[NbSEDY[0]++] ) Pad();
						pad->Q = data & 0x0FFF; pad->Which = BufferGANIL::gItemSEDY0[itemid];
					break;
					case 4:
						//printf("Case 4 \n");
						//fItemSED1X->Fill(BufferGANIL::gItemSEDX1[itemid]);
						pad = new( arSED1X[NbSEDX[1]++] ) Pad();
						pad->Q = data & 0x0FFF; pad->Which = BufferGANIL::gItemSEDX1[itemid];
					break;
					case 5:
						//printf("Case 5 \n");					
						//fItemSED1X->Fill(BufferGANIL::gItemSEDX1[itemid+64]);
						pad = new( arSED1X[NbSEDX[1]++] ) Pad();
						pad->Q = data & 0x0FFF; pad->Which = BufferGANIL::gItemSEDX1[itemid+64];
					break;	
					case 6:
						//printf("Case 6 \n");
						//fItemSED1Y->Fill(BufferGANIL::gItemSEDY1[itemid]);
						pad = new( arSED1Y[NbSEDY[1]++] ) Pad();
						pad->Q = data & 0x0FFF; pad->Which = BufferGANIL::gItemSEDY1[itemid];
					break;	
					case 7:
						//printf("Case 7 \n");
						if ( BufferGANIL::gItemQSED0[itemid] != -1 ) 
							QSED0[BufferGANIL::gItemQSED0[itemid]] = data & 0x3FFF;
						if ( BufferGANIL::gItemQSED1[itemid] != -1 ) 		
							QSED1[BufferGANIL::gItemQSED1[itemid]] = data & 0x3FFF;
						if ( itemid == BufferGANIL::gItemQPLG ) QPL_G =  data & 0x3FFF;
						if ( itemid == BufferGANIL::gItemQPLD ) QPL_D =  data & 0x3FFF;						
					break;
					default:
						printf("%d \n",BufferGANIL::gGroupTableVAMOS[detectorid]);
					break;
				} // switch
			} // if 
		} // i
	}
	// printf("VAMOS \n"); 
	return ok;

}	
	
/*

Bool_t ExogamR::Fill(UShort_t *data_stream, UShort_t data_stream_length) 
{	
	ExoClover *clover; Bool_t ok;
	// detector id says to what familly of detector belongs the following data_stream
	// item id says what is coded: energy, tac ... 
	UShort_t subtoken, sublength, detectorid, itemid;
	UShort_t specifier, data;
	
	Clear("C");
	TClonesArray &ar = *Clovers; 
	UShort_t link[256]; ::memset(link,0,512);
	
	
	ok = kFALSE; UShort_t pos = 3;
	//printf(" data_stream_length %d \n",data_stream_length);
	while ( pos < data_stream_length ) {

		subtoken = data_stream[pos++];
		//if ( loop < 10) cout << "subevent token :" << data_stream[pos] << endl;		
		// if ( subtoken != fStartSubEventToken ) printf("WRONG sub event token %x \n",subtoken);

		sublength = ( data_stream[pos++] - 2 )/2;
		// printf("subevent length : %d \n ",sublength); 

		for (UShort_t  i = 0; i < sublength; i++) {
	
			//if ( l < 10) printf("Start subevent %d %d\n ",i,sublength);
		        specifier = data_stream[pos++]; data = data_stream[pos++];
			
			//if ( loop < 10) printf(" specifier %d data %d\n ",i,sublength);
			detectorid = specifier & 0x00FF;
			//fGroupDistribution->Fill(detectorid);
			
			if ( BufferGANIL::gGroupTableECC[detectorid] != -1 ) { // clover GE detector
			
				ok = kTRUE;
				
				itemid = (specifier & 0x3F00) >> 8; // fItemDistribution->Fill(itemid); 
						
				if ( link[BufferGANIL::gGroupTableECC[detectorid]] == 0 ) {
					// printf("get new GE %d \n ",BufferGANIL::gGroupTableECC[detectorid]);
					link[BufferGANIL::gGroupTableECC[detectorid]] = NbClover+1;		
					clover = new( ar[NbClover++] ) ExoClover();
					//clover->Clear("");
					clover->Which = BufferGANIL::gGroupTableECC[detectorid];
				}
				else {
					// printf("get old at position GE %d \n ",link[BufferGANIL::gGroupTableECC[detectorid]]-1);				
					clover = new( ar[link[BufferGANIL::gGroupTableECC[detectorid]]-1] ) ExoClover();
					//clover->SetWhich(gGroupTableC[detectorid]);
				}
				//printf("item GEHR0 %d \n ",itemid);
				if ( itemid == BufferGANIL::gItemHR[0] ) {
					if ( TESTBIT(specifier,15) ) clover->SetPileUp(kTRUE,0);
					if ( TESTBIT(specifier,14) ) clover->SetCompton(kTRUE,0);				
					clover->SetEnergy(data & 0x3FFF,0);
				}
				//printf("item GEHR1 %d \n ",itemid);				
				if ( itemid == BufferGANIL::gItemHR[1] ) {
					if ( TESTBIT(specifier,15) ) clover->SetPileUp(kTRUE,1);
					if ( TESTBIT(specifier,14) ) clover->SetCompton(kTRUE,1);				
					clover->SetEnergy(data & 0x3FFF,1); 		
				}
				//printf("item GEHR2 %d \n ",itemid);				
				if ( itemid == BufferGANIL::gItemHR[2] ) {
					if ( TESTBIT(specifier,15) ) clover->SetPileUp(kTRUE,2);
					if ( TESTBIT(specifier,14) ) clover->SetCompton(kTRUE,2);				
					clover->SetEnergy(data & 0x3FFF,2);			
				}
				//printf("item GEHR3 %d \n ",itemid);				
				if ( itemid == BufferGANIL::gItemHR[3] ) {
					if ( TESTBIT(specifier,15) ) clover->SetPileUp(kTRUE,3);
					if ( TESTBIT(specifier,14) ) clover->SetCompton(kTRUE,3);				
					clover->SetEnergy(data & 0x3FFF,3); 				
				}
				//printf("item GELR %d \n ",itemid);								
				if ( itemid == BufferGANIL::gItemLR[0] ) { clover->SetEnergyLR(data & 0x3FFF,0); }
				if ( itemid == BufferGANIL::gItemLR[1] ) { clover->SetEnergyLR(data & 0x3FFF,1); }
				if ( itemid == BufferGANIL::gItemLR[2] ) { clover->SetEnergyLR(data & 0x3FFF,2); }
				if ( itemid == BufferGANIL::gItemLR[3] ) { clover->SetEnergyLR(data & 0x3FFF,3); }
				//printf("item GELR %d \n ",itemid);																
				if ( itemid == BufferGANIL::gItemT[0] ) { clover->SetTime(data & 0x7FFF,0);}
				if ( itemid == BufferGANIL::gItemT[1] ) { clover->SetTime(data & 0x7FFF,1); }
				if ( itemid == BufferGANIL::gItemT[2] ) { clover->SetTime(data & 0x7FFF,2); }
				if ( itemid == BufferGANIL::gItemT[3] ) { clover->SetTime(data & 0x7FFF,3);}
			} // clover
			
			if ( BufferGANIL::gGroupTableESS[detectorid] != -1 ) { // shield detector
			
				itemid = (specifier & 0x3F00) >> 8; // fItemDistribution->Fill(itemid); 
						
				if ( link[BufferGANIL::gGroupTableESS[detectorid]] == 0 ) {
					//printf("get new ESS %d \n ",detectorid);
					link[BufferGANIL::gGroupTableESS[detectorid]] = NbClover+1;	
					clover = new( ar[NbClover++] ) ExoClover();
					clover->SetWhich(BufferGANIL::gGroupTableESS[detectorid]);
				}
				else {
					//printf("get old at position ESS %d \n ",link[BufferGANIL::gGroupTableESS[detectorid]]-1);				
					clover = new( ar[link[BufferGANIL::gGroupTableESS[detectorid]]-1] ) ExoClover();
					//clover->SetWhich(gGroupTableC[detectorid]);
				}

				if ( itemid == BufferGANIL::gItemSE )   { clover->SetShieldE(data & 0x0FFF);}
				if ( itemid == BufferGANIL::gItemSP )   { clover->SetShieldP(data & 0x0FFF);}
				if ( itemid == BufferGANIL::gItemSTAC)  { clover->SetShieldT(data & 0x0FFF);}
				if ( itemid == BufferGANIL::gItemST[0]) { clover->SetTimeS(data & 0x0FFF,0);}	
				if ( itemid == BufferGANIL::gItemST[1]) { clover->SetTimeS(data & 0x0FFF,1);}	
				if ( itemid == BufferGANIL::gItemST[2]) { clover->SetTimeS(data & 0x0FFF,2);}
				if ( itemid == BufferGANIL::gItemST[3]) { clover->SetTimeS(data & 0x0FFF,3);}
			} // shield
			
			if ( BufferGANIL::gGroupTableGOCCE[detectorid] != -1 ) { // GOCCE
					
				if ( link[BufferGANIL::gGroupTableGOCCE[detectorid]] == 0 ) {
					// printf("get new GOCCE %d \n ",detectorid);
					link[BufferGANIL::gGroupTableGOCCE[detectorid]] = NbClover+1;	
					clover = new( ar[NbClover++] ) ExoClover();
					clover->SetWhich(BufferGANIL::gGroupTableGOCCE[detectorid]);
				}
				else {
					// printf("get old GOCCE at position %d \n ",link[BufferGANIL::gGroupTableGOCCE[detectorid]]-1);				
					clover = new( ar[link[BufferGANIL::gGroupTableGOCCE[detectorid]]-1] ) ExoClover();
					//clover->SetWhich(gGroupTableC[detectorid]);
				}
				itemid = (specifier & 0x3F00) >> 8;
				
				switch( itemid / 8  ){
					case 0:
						// cristal A
						if ( (itemid % 8) < 4 ) clover->SetGocceE(data & 0x3FFF,0,itemid % 8);
						else clover->SetGocceT(data & 0x3FFF,0,(itemid%8)-4);	
					break;
					case 1:
						// cristal B
						if ( (itemid % 8) < 4 ) clover->SetGocceE(data & 0x3FFF,1,itemid % 8);
						else clover->SetGocceT(data & 0x3FFF,1,(itemid%8)-4);		
					break;	
					case 2:
						// cristal C					
						if ( (itemid % 8) < 4 ) clover->SetGocceE(data & 0x3FFF,2,itemid % 8);
						else clover->SetGocceT(data & 0x3FFF,2,(itemid%8)-4);	
					break;
					case 3:
						// cristal D					
						if ( (itemid % 8) < 4 ) clover->SetGocceE(data & 0x3FFF,3,itemid % 8);
						else clover->SetGocceT(data & 0x3FFF,3,(itemid%8)-4);
					break;	
					default:
						printf("Wrong item %d for GOCCE # %d \n",itemid,BufferGANIL::gGroupTableGOCCE[detectorid]);
					break;
				} // switch	
			}	
			
		} // i
	} // pos
	
	printf("NbClover %d \n",NbClover);
	return ok;
	
//	if ( NbClover > 0 ) return kTRUE;
//	return kFALSE;
}
*/

ClassImp(VamosC);

VamosC::VamosC()
{
	Clear("");
	VamosC::Class()->IgnoreTObjectStreamer();
}

VamosC::~VamosC()
{
;
}

void VamosC::Clear(Option_t *opt)
{
	X1 = 0.0;
	Y1 = 0.0;
	X2 = 0.0;
	Y2 = 0.0;
	Xfoc = 0.0;
	Yfoc = 0.0;
	Thetafoc = 0.0;
	Phifoc = 0.0;
	BRho = 0.0;
	Thetaphys = 0.0;
	Phiphys = 0.0;
	Tof = 0.0;
	vof = 0.0;
	for ( Int_t i = 0; i < 7; i++ ) deltaE[i] = 0.0;
	for ( Int_t i = 0; i < 7; i++ ) Eres[i] = 0.0;	
} 

