#include<iostream>
using namespace std;

#include<Peak.h>
#include<TMath.h>
#include<FuzzySet.h>

ClassImp(Peak);

Peak::Peak(){ //Default Constructor
	fPosition = 0.0;
	fIntensity = 0.0;
	fResolution = 0.0;
}

Peak::Peak(const Float_t *par){
	fPosition = par[0];
	fIntensity = par[1];
	fResolution = par[2];
}

Peak::Peak(const Float_t position, const Float_t intensity){
	fPosition = position;
	fIntensity = intensity;
	fResolution = 0.0;
}

Peak::Peak(const Float_t position, const Float_t intensity, const Float_t resolution) {
	fPosition = position;
	fIntensity = intensity;
	fResolution = resolution;
}


void Peak::SetPos(const Float_t value){
	fPosition = value;
}

void Peak::SetInt(const Float_t value){
	fIntensity = value;
}

void Peak::SetRes(const Float_t value){
	fResolution = value;
}

Float_t Peak::GetPos() const{
	return(fPosition);
}

Float_t Peak::GetInt() const{
	return(fIntensity);
}

Float_t Peak::GetRes() const{
	return(fResolution);
}


