#ifndef PEAK_H
#define PEAK_H

#include<TObject.h>
#include<TObjArray.h>

/* Class Peak
	A peak is defined by a position, an intensity and a resolution

*/


class Peak : public TObject{
public:
	Peak();
	Peak(const Float_t *);
	Peak(const Float_t, const Float_t);
	Peak(const Float_t, const Float_t, const Float_t);


	void SetPos(const Float_t);
	void SetInt(const Float_t);
	void SetRes(const Float_t);

	Float_t GetPos() const;
	Float_t GetInt() const;
	Float_t GetRes() const;







private:
	Float_t fPosition;    //Position of the peak in energy
	Float_t fIntensity;   //Intensity of the peak
	Float_t fResolution;  //Resolution of the peak
	TObjArray fFuzzyList; //Liste of FuzzySet for the reference peaks

public:
	ClassDef(Peak,1);

};

#endif
