

#ifndef Gw_EnsdfLevelSchemeReader
#define Gw_EnsdfLevelSchemeReader

#ifndef ROOT_TString
#include <TString.h>
#endif

#ifndef Gw_BaseLevelSchemeReader
#include "BaseLevelSchemeReader.h"
#endif

#ifndef GW_LEVELSCHEME_H
#include "LevelScheme.h"
#endif

namespace Gw {

/** A EnsdfLevelSchemeReader class to read radware level scheme files

*/
class EnsdfLevelSchemeReader : public BaseLevelSchemeReader {

public:
  
  EnsdfLevelSchemeReader(const char* filename, Option_t* opt);
  virtual ~EnsdfLevelSchemeReader();
    
  //! check file before imported level scheme
  virtual Int_t Check();  
  //! fill labels
  virtual void FillLabels( LevelScheme& levelScheme); 

private:
 
  //! set dsid
  TString GetDsid();
  
  //! set nuclide
  TString GetNuclide();

  
};

} // end namespace
#endif
