/***************************************************************************
 *   Copyright (C) 2004-2006 by Olivier Stezowski & Christian Finck        *
 *   stezow(AT)ipnl.in2p3.fr, cfinck(AT)ires.in2p3.fr                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,									   *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/** \file SymCorrelatedSpace.cpp compiled in libGWPHYSICS.so */

#ifndef Gw_SymCorrelatedSpace
#include "SymCorrelatedSpace.h"
#endif

#ifndef ROOT_TH1D
#include "TH1D.h"
#endif

#ifndef ROOT_TList
#include "TList.h"
#endif

#ifndef ROOT_TString
#include "TString.h"
#endif

using namespace Gw;

//
ClassImp(SymCorrelatedSpace)

//__________________________________________________________
SymCorrelatedSpace::SymCorrelatedSpace() 
  : CorrelatedSpace()
{ 
  // default constructor
  fLog.GetProcessName() = "SymCorrelatedSpace";
}

//__________________________________________________________
SymCorrelatedSpace::SymCorrelatedSpace(const char* name, const char* title) 
: CorrelatedSpace(name, title)
{ 
  fLog.GetProcessName() = "SymCorrelatedSpace";
}

//__________________________________________________________
SymCorrelatedSpace::~SymCorrelatedSpace()
{
  // default destructor
}

//__________________________________________________________
Int_t SymCorrelatedSpace::GetAxisNumber(Option_t* /*name*/) const
{
  return 0;
}

//__________________________________________________________
void SymCorrelatedSpace::SetDimension(Int_t dimension)
{
  fDimension = dimension;  

  TH1D* h1 = new TH1D("hp", "Axis Projection", 1, 0, 1);
  fHistoList->Add(h1);
  
  TH1D* h1b = new TH1D("hpBkg", "Axis Bkg Projection", 1, 0, 1);
  fHistoBkgList->Add(h1b);
  
  TH1D* h1t = new TH1D("hpTot", Form("%s %s",GetName(), "Axis Total Projection"), 1, 0, 1);
  fHistoTotList->Add(h1t);
}

//__________________________________________________________
void SymCorrelatedSpace::Project(Option_t* axis, Option_t* gateName) 
{ 
  CorrelatedSpace::Project(axis, gateName); 
}

