
#ifndef Gw_AgataTrackDisplayEditor
#define Gw_AgataTrackDisplayEditor

#ifndef ROOT_TGedFrame
#include "TGedFrame.h"
#endif

#include "GwLogMessage.h"

class TGWindow;
namespace Gw {

/** AgataTrackDisplayEditor a class to edit tracks display
 
*/

class AgataTrackDisplay;
  
class AgataTrackDisplayEditor : public TGedFrame
{

public:
  AgataTrackDisplayEditor(const TGWindow* p=0, Int_t width=170, Int_t height=30,
                          UInt_t options=kChildFrame, Pixel_t back=GetDefaultFrameBackground());
  virtual ~AgataTrackDisplayEditor();
  
  //! Set model (->AgataTrackDisplay)
  virtual void SetModel(TObject* obj);
  
  //! Do histo for total energy of the track
  virtual void DoHisto();
  
  //! Do histo for total energy of the track (for a given range)
  virtual void DoRangeHisto();
  
  //! Plot histo
  virtual void PlotHisto(Int_t min, Int_t max);
      
protected:
  
  AgataTrackDisplay* fM; // pointer to set model
  
  mutable LogMessage fLog;   //! log message

  ClassDef(AgataTrackDisplayEditor, 0);  
};

} // end namespace

#endif
