/***************************************************************************
 *   Copyright (C) 2004-2006 by Olivier Stezowski & Christian Finck        *
 *   stezow(AT)ipnl.in2p3.fr, cfinck(AT)ires.in2p3.fr                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   FreBaseEventContainere Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/** \file BaseEventContainer.cpp compiled in libGWTOOLS.so */



#ifndef Gw_BaseEventContainer
#include "BaseEventContainer.h"
#endif

using namespace Gw;

//
ClassImp(BaseEventContainer)

//__________________________________________________________
BaseEventContainer::BaseEventContainer() 
  : TObject(),
    fEventTree(new TTree()),
	fNofEvents(0),
    fLog("BaseEventContainer")
{ 
  // default constructor
}

//__________________________________________________________
BaseEventContainer::~BaseEventContainer()
{
  // default destructor
  
  delete fEventTree;
}

//__________________________________________________________
void BaseEventContainer::GetEvent(Int_t ievent)
{  
  if (ievent >= fEventTree->GetEntries()) {
	fLog.SetProcessMethod("GetEvent(Int_t )");
    fLog << "index too large" << dolog;
    return;
  }
  
  fEventTree->GetEntry(ievent);
  
}
  



