


#ifndef Gw_BaseEventContainer
#define Gw_BaseEventContainer

#include "GwLogMessage.h"

#ifndef ROOT_TObject
#include "TObject.h"
#endif

#ifndef ROOT_TTree
#include "TTree.h"
#endif

#ifndef ROOT_TString
#include "TString.h"
#endif

class TClonesArray;
namespace Gw {

/** BaseEventContainer base class that contains event for display
 
*/
class BaseEventContainer : public TObject
{
  
protected:
  
  TTree* fEventTree;          // pointer to tree
  Int_t  fNofEvents;          // max number of entries
  
  mutable LogMessage fLog;    //! log message

public:
  BaseEventContainer();
  virtual ~BaseEventContainer();
  
  //! get Number of events
  Int_t GetNofEvents() const { return fNofEvents;}
  
  //! get event
  void GetEvent(Int_t ievent);
      
  ClassDef(BaseEventContainer,0)  // event container
};
  
} // end namespace

#endif
