/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GWS_BASE_H
#define GWS_BASE_H

/** \file Base.h interface to the operating system
*
* 
*/

#ifndef ROOT_Rtypes
#include <Rtypes.h>
#endif

class TSystem;

//! namespace for any classes that are close to the operating system 
/*!

	ROOT provides an interface to the operating system through the gSystem pointer (TSystem class). The purpose of these classes 
	is not to re-defined them but to provide some missing componants like for instance actions on DLT. \n
	Any Gammaware classes that interface some aspect of the operating system inherits from this base classe.
	 
	Gws is for GammaWare System 
	
	\todo - any functions which wraps a system call should throw an Exception error
*/
namespace Gws
{

/*
struct IO 
{ 
// open mode for IO
    static const int kIn;            // read only
    static const int kOut;           // write only
    static const int kInOut;         // read and write
    static const int kAppend;        // append mode
    static const int kCreat;         // if the file does't exist it will be creat
    static const int kTrunc;         // length of the file truncated to 0     
};


struct Seek
{
// to seek
    static const int kBeg;	// seek from the beginning
    static const int kCur;	// seek from the current position
    static const int kEnd;	// seek from the end
};
 
struct Perm
{
// to set permission
    static const mode_gw kUserR;
    static const mode_gw kUserW;
    static const mode_gw kUserX;
    static const mode_gw kUserRWX;
    static const mode_gw kGroupR;
    static const mode_gw kGroupW;
    static const mode_gw kGroupX;
    static const mode_gw kGroupRWX;
    static const mode_gw kWorldR;
    static const mode_gw kWorldW;
    static const mode_gw kWorldX; 
    static const mode_gw kWorldRWX;
};
*/

//! Interface to the operating system. 
/*!
	detail
*/
class Base 
{
protected:

public:
    Base();
    virtual ~Base();
    
    TSystem *SystemROOT();
    
    //! ask the system about some quantities
    /*!
	detail
    */
    // static long int MaxLengthPath();
    // static long int MaxLengthFileName();
};

// Base inline members ////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

} // namespace Gws



#endif
