/***************************************************************************
 *   Copyright (C) 2004 by Olivier Stezowski                               *
 *   stezow(AT)ipnl.in2p3.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GWS_TYPES_H
#define GWS_TYPES_H

//! redefinition of some system types
/*!
	- mode_gw 
	- off_gw:	offset for io
	- size_gw:	sizt type 
*/
#include <sys/types.h>
typedef mode_t   mode_gw;     // permission for files Read, write or execute
typedef off_t    off_gw;      // offset type
typedef size_t   size_gw;     // size type - something like unsigned int or long

// Maximum length for any multibyte character for standard 32-bit words.

/* Minimum and maximum values a `signed 8 bits' can hold.  */
#define GWS_SCHAR_MIN   (-128)
#define GWS_SCHAR_MAX	 127

/* Maximum value an `unsigned 8 bits' can hold.  */
#define GWS_UCHAR_MIN	 0
#define GWS_UCHAR_MAX	255

/* Minimum and maximum values a `signed 16 bits' can hold.  */
#define GWS_SINT16_MIN	(-32768)
#define GWS_SINT16_MAX	 32767

/* Maximum value an `unsigned 16 bits' can hold.  */
#define GWS_UINT16_MIN	  0
#define GWS_UINT16_MAX	65535

/* Minimum and maximum values a `signed 32 bits' can hold.  */
#define GWS_SINT32_MAX	   2147483647
#define GWS_SINT32_MIN  (-GS_SINT32_MAX - 1)

/* Maximum value an `unsigned 32 bits' can hold.  */
#define GWS_UINT32_MIN	     0
#define GWS_UINT32_MAX	4294967295U

/* Minimum and maximum values a `signed 64 bits' can hold.  */
#define GWS_SINT64_MAX	   2147483647L
#define GWS_SINT64_MIN  (-GS_SINT64_MAX - 1L)

/* Maximum value an `unsigned 64 bits' can hold. */
#define GWS_UINT64_MIN	     0
#define GWS_UINT64_MAX	4294967295UL

#endif
